// weakPtr1.cpp
// Demo zu weak_ptr.
// --------------------------------------------------
#include <iostream>
#include <memory>
using namespace std;

void print( weak_ptr<int> wp)    // Call by value (Kopierkonstruktor)
{
   shared_ptr<int> sp = wp.lock();
   if( sp)                       // Falls Objekt noch existiert
      cout << "Adresse: " << sp << "   Wert: " << *sp << endl;
   else
      cout << "Objekt nicht mehr vorhanden!" << endl;
}

int main()
{
   shared_ptr<int> sp(new int(7));
//   shared_ptr<int> sp = make_shared<int>(7);  // Alternative
   weak_ptr<int> wp1  ,                // Leerer Zeiger
                 wp2(sp);              // Verweis auf *sp
   wp1 = sp;                 // ok, alle zeigen jetzt auf *sp.

   cout << "Referenzzaehler: " << wp2.use_count() << endl;  // 1
   print(wp2);
   sp.reset();               // Zerstrt *sp
   print(wp2);               // wp.lock() ist leer.

   try
   {
      shared_ptr<int> sp(wp2);     // Exception bad_weak_ptr.
      cout << "Diese Anweisung wird nicht erreicht" << endl;
   }
   catch( bad_weak_ptr& e) { cerr << e.what() << endl; }
   catch(...) { cerr << "Unerwartete Exceptionn!" << endl; }

   return 0;
}
