// RandomFunktor.h
// Definiert die Klasse RandomFunktor zur Darstellung eines
// Funktionsobjekts.
// -----------------------------------------------------------
#include <thread>
#include <mutex>
#include <cstdlib>
#include <iostream>
#include <iomanip>
using namespace std;

// extern mutex mtx;                    // Extern-Deklaration
// Seit C++17 inline mglich:
inline mutex mtx;

class RandomFunktor
{
     static inline int count = 0;     // Fr die Thread-Nummer

   public:
     static int getCount()  { return count; }

     void operator()(unsigned n)
     {
         lock_guard<mutex> lock(mtx);

         count++;
         srand( count);
         cout << count << ". Thread wird ausgefuehrt: "
              << "\nThread-ID = " << this_thread::get_id()
              << endl;
         cout <<  n << " Zufallszahlen: " << endl;

         for (unsigned i = 0; i < n; i++)
         {
                cout << setw( 4) << rand() % 100;
                if( (i > 0) && (i % 10 == 9)) cout << endl;
         }
         cout << endl;
    }
};
