// find_elem.cpp: Bestimmte Elemente suchen.
// ---------------------------------------------------------------
#include <iostream>
#include <deque>            // Definition des deque-Templates
#include <algorithm>        // Definition der Algorithmen-Templates
#include <functional>       // Vordefinierte Funktionsobjekte
using namespace std;

void print( int elm) {  cout.width(4);  cout << elm; }
bool odd(int elm) {  return elm % 2 == 1; }

int main()
{
    deque<int> intDeque;                 // Leere Deque anlegen

    for( int i = 0; i < 5; ++i)          // Elemente einfgen:
      intDeque.push_front(i),            // am Anfang,
      intDeque.push_back(i);             // am Ende.

    // intDeque anzeigen: 
    for_each( intDeque.begin(), intDeque.end(), print);  
    cout << endl;                        // 4 3 2 1 0 0 1 2 3 4

    // Die erste 0 suchen und Bereich bis dahin (incl. 0) anzeigen:
    auto iter = find( intDeque.begin(), intDeque.end(), 0); 
    if( iter != intDeque.end())           // Falls 0 gefunden:
      for_each( intDeque.begin(), iter+1, print), 
      cout << endl;

    // Letzte ungerade Zahl suchen und Bereich bis dahin anzeigen:
    auto riter = find_if( intDeque.rbegin(), intDeque.rend(), odd); 
    if( riter != intDeque.rbegin())       // Falls ungerade Zahl vorhanden:
        for_each( intDeque.begin(), riter.base(), print),
        cout << endl;

    // Die erste Zahl 0 oder 1 suchen und Bereich bis dahin anzeigen:
    int suchen[] = { 0, 1 };
    iter = find_first_of( intDeque.begin(), intDeque.end(), suchen, suchen+2);
    if( iter != intDeque.end())           // Falls 0 oder 1 gefunden:
      for_each( intDeque.begin(), iter+1, print),
      cout << endl;

    return 0;
}

/* Ausgabe:
   4   3   2   1   0   0   1   2   3   4
   4   3   2   1   0
   4   3   2   1   0   0   1   2   3
   4   3   2   1
*/
