// funcObj.h: Beispielklassen fr Funktionsobjekte.
// ---------------------------------------------------------------
#include <iostream>
using namespace std;

// Klasse zur formatierten Ausgabe von Gleitpunktzahlen
class PrintDbl
{
  private:               // Daten zur Formatierung der Ausgabe:
    int zaehler, spalten,  // Fr die Anzahl Spalten pro Zeile.
        feldbreite,        // Feldbreite
        genauigkeit;       // Nachkommastellen
    ios::fmtflags fmtfl;   // Zur Sicherung der Formatflags
  public:
    // Konstruktor
    PrintDbl(int sp = 5, int br = 10, int gen = 2)
    : zaehler(0), spalten(sp), feldbreite(br), genauigkeit(gen)
    {
        fmtfl = cout.flags();              // Formatflags sichern.
        cout.precision( genauigkeit); cout.setf(ios::fixed);
    }
    // Destruktor                          // Formatflags wieder herstellen.
    ~PrintDbl() { cout.clear();  cout.flags(fmtfl);  }

    // Element ausgeben:
    void operator() ( double x)
    {
       cout.width(feldbreite); cout << x;
       if( ++zaehler % spalten == 0)
          cout << endl;
    }
};

// Klasse fr Funktionsobjekte, die Summen bilden.
class Summe
{
  private:
    double summe;      // Aktuelle Summe
    int anzahl;        // Aktuelle Anzahl
  public:
    // Konstruktor:
    Summe() : summe(0.0), anzahl(0)
    {}
    // Element hinzuaddieren:
    void operator()( double x) { summe += x; ++anzahl; }
    // Get-Methoden:
    double getSumme() const { return summe; }
    int getAnzahl() const { return anzahl; }
};
