// apply.cpp: Verwendung der valarray-Methode apply()
// ---------------------------------------------------
#include <complex>
#include <valarray>
#include <iostream>
#include <iomanip>
using namespace std;

typedef complex<double> COMPLEX;

COMPLEX func(COMPLEX z);

int main()
{
   valarray<COMPLEX> v = { COMPLEX(0,0), COMPLEX(1,0),
                           COMPLEX(0,1), COMPLEX(1,1) };
                           // Aufruf mit einer Standardfunktion:
   valarray<COMPLEX> vc = v.apply(conj);  
                           // Aufruf mit selbstdef. Funktion:
   valarray<COMPLEX> vf = v.apply(func);
         
   cout << "  z       conj(z)          exp(i*z) "; 
   cout << setprecision(3) << endl;
 
   for(int j=0; j < 4; j++)
   {
     cout << left << setw(10) <<  v[j];   
     cout << left << setw(17) <<  vc[j]; 
     cout << left << setw(17) <<  vf[j];
     cout << endl;
   }
   return 0;
}

COMPLEX func(COMPLEX z)
{
    return exp( COMPLEX(0,1)*z );     // exp(i*z)
}
