// mandelbrot.cpp:  Testet, ob eine komplexe Zahl c
//                  zur Mandelbrot-Menge gehrt.
// ----------------------------------------------------
#include <complex>
#include <iostream>
using namespace std;

#define count 10000

bool mandelbrot(const complex<double>& c)
{
   complex<double> z(0.0, 0.0);
   for(int i=0; i < count; i++)
   {
      z = z*z + c;
      if(abs(z) > 2)
        return false;  // c gehrt nicht zu M
   }
   return true;        // Wahrscheinlich gehrt c zu M.
}

int main()
{
  complex<double> z(-1.1, 0.2);

  const char *no = mandelbrot(z) ? "" : "nicht ";
  cout << z << " gehoert " << no << "zur Mandelbrot-Menge" << endl;

  cout << "Geben Sie eine komplexe Zahl ein "
       << "(Format: x, (x) oder (x,y)):" << endl;
  cin >> z;
  no = mandelbrot(z) ? "" : "nicht ";
  cout << z << " gehoert " << no << "zur Mandelbrot-Menge" << endl;

  return 0;
}
