// polynom_t.cpp:     Klasse Polynom testen
// ----------------------------------------------------
#include "matrix.h"
#include <iostream>
#include <iomanip>
using namespace std;

template<class T>
void display( const Matrix<T>& m);

int main()
{
    double elem[9] = { 1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 7.0, 8.0, 9.0 };
    Matrix<double> m(elem,2,3);    // Matrix mit den ersten 6 Elementen
    cout << "1. Matrix:" << endl;
    display(m);

    Matrix<double> m2(m);
    m2(1,2) = 7.0;
    cout << "2. Matrix:" << endl;
    display(m2);

    Matrix<double> sm = m.subMatrix(0,1,1,1); // Matrix von (0,1)
    cout << "Sub-Matrix:" << endl;            // bis (1,1)
    display(sm);                              // = 2. Spalte

    Matrix<double> mi = m.minor(0,1);         // 1. Zeile und
    cout << "Minor(0,1):" << endl;            // 2. Spalte streichen
    display(mi);

    Matrix<double> tm = m.transponierte();    // An der Diagonalen
    cout << "Transponierte:" << endl;         // spiegeln.
    display(tm);

    Matrix<double> mm(elem,3,3);
    cout << "Quadratische Matrix:" << endl;
    display(mm);

    Matrix<double> null(3,3),                 // Rechte obere Ecke mit
                   ut = mm.upperTriangle(null);  // 0.0 berschreiben.
    cout << "upperTriangle:" << endl;
    display(ut);

    return 0;
}

template<class T>
void display( const Matrix<T>& m)
{
    for( size_t r = 0; r < m.getRows(); ++r)
    {
        for( size_t c = 0; c < m.getCols(); ++c)
            cout << setw(6) << m[r][c];
        cout << endl;
    }
}
