// namesp2.cpp
// Zeigt die Verwendung von using-Deklaration und
// using-Direktive.
// ----------------------------------------------------

#include <iostream>       // Namensbereich std  

void message()            // globale Funktion ::message()  
{
   std::cout << "In der Funktion ::message()\n";
}

namespace A
{
   using namespace std;   // Namen aus std hier sichtbar
   void message()         // Funktion A::message()  
   {
     cout << "In der Funktion A::message()\n";
   }
}

namespace B
{
   using std::cout;       // cout aus std deklarieren
   void message(void);    // Funktion B::message()  
}

void B::message(void)     // Definition von B::message()  
{
   cout << "In der Funktion B::message()\n";
}

int main()
{
   using namespace std;   // Namen aus std 
   using B::message;      // Funktionsname ohne Klammern

   cout << "Test mit Namensbereichen!\n"; 

   cout << "\nAufruf von A::message()" << endl; 
   A::message();          

   cout << "\nAufruf von B::message()" << endl; 
   message();             // wegen using-Deklaration
                          // Verdeckt ::message()
   cout << "\nAufruf von ::message()" << endl; 
   ::message();           // globale Funktion

   return 0;
}
