// strucbind.cpp 
// Eine Struktur entpacken.
// ---------------------------------------------------
#include <iostream>
#include <string>
using namespace std;

struct Vertreter    // Definition der Struktur Vertreter
{
    string name;         // Name des Vertreters.
    double umsatz;       // Sein Umsatz pro Monat.
};

inline Vertreter& incUmsatz(Vertreter& v, double inc)
{
    auto&[nref, uref] = v;
    uref += inc;              //Umsatz erhhen
    return v;
}

int main()
{
    Vertreter v = { "Sturm, Heidi", 4950.99 };     

    auto[nm, um] = v;     // Strukturelemente entpacken.
    cout << "\nDie entpackte Struktur: " << endl; 
    cout << "Name: " << nm << "\nUmsatz: " << um << endl; 

    // Referenzen auf die Datenelemente der Struktur: 
    auto&[nref, uref] = v; 

    nref = "Winter, Heidi";    // Name ndern  

                               // Umsatz erhhen: 
    auto[r1, r2] = incUmsatz(v, 5000.0); 

    cout << "\nAenderungen in der entpackten Struktur: ";
    cout << "\nName: " << r1 << "\nUmsatz: " << r2 << endl;
    
    cout << "\nDie geaenderte Struktur: " << endl; 
    cout << "Name: " << v.name 
         << "\nUmsatz: " << v.umsatz << endl; 
    return 0; 
}
