// -------------------------------------------------------
// telList.h
// Eine Klasse TelList zur Darstellung einer
// Liste mit Namen und Telefonnummern. 
// Die Methoden load(), save() und saveAs() dienen zum
// Laden und Speichern einer Telefon-Liste.
// -------------------------------------------------------
#ifndef TelList_H
#define TelList_H

#include <string>
using namespace std;
    
#define PSEUDO -1          // Pseudo-Position
#define MAX 100            // Maximale Anzahl Elemente
 
// Typ eines Listen-Elementes:
struct Element { string name, telNr; };  

class TelList
{
  private:
    Element v[MAX];        // Der Vektor und die
    int count;             // aktuelle Anzahl Elemente

    string filename;       // Dateiname 
    bool dirty;            // true, falls Daten verndert
                           // und noch nicht gespeichert. 
  public:
    TelList() : count(0), filename(""), dirty(false)
    {}

    int getCount() const { return count; }

    Element *retrieve( int i )
    { 
       return (i >= 0 && i < count)? &v[i] : NULL;
    }
    bool append( const Element& el )
    { 
       return append( el.name, el.telNr);
    }
    bool append( const string& name, const string& telNr);
    bool erase( const string& name);
    int  search( const string& name) const;
    void print() const;
    int  print( const string& name) const;
    int  getNewEntries();

    const string& getFilename() const { return filename; }
    bool setFilename( const string& fn)
    { 
       if( fn.empty())
          return false;
       else
       { 
          filename = fn;
          dirty = true;
          return true;
       }
    }

    bool isDirty() const { return dirty; }

    bool load();
    bool save();
    bool saveAs();
};
 
#endif  // TelList_H
