// -------------------------------------------------------
//  TelList_.cpp
//  Mit der Klasse TelList eine Telefon-Liste verwalten.
// -------------------------------------------------------
//  Statt der ANSI-Bildschirmsteuerzeichen fr CLS wird
//  die Funktion cls() aus console.cpp verwendet.
//  ==> Die Quelldatei console.cpp im Projekt aufnehmen!
// -------------------------------------------------------

#include <iostream>
#include <string>
#include <cctype>
using namespace std;

#include "telList.h"             // Definition der Klasse TelList
#include "..\..\console\console.h"  // Win32 Konsolenfunktionen

inline void weiter()
{
   cout << "\n\nWeiter mit der Return-Taste! ";
   cin.get();
}

int menu();              // Ein Kommando einlesen
char askForSave();       // Abfrage, ob gespeichert werden soll.

char header[] =
"\n\n            * * * * *  Telefon-Liste  * * * * *\n\n";

TelList myFriends;       // Eine Telefon-Liste

int main()
{
  int aktion = 0;        // Kommando
  string name;           // Zum Einlesen eines Namens

  while( aktion != 'B')
  {
    aktion = menu();
    cls();
    cout << header << endl;

    switch( aktion)
    {
      case 'A':  myFriends.print();              // Alles anzeigen
                 weiter();
                 break;
      case 'F':                                  // Suchen
                 cout << "\n--- Telefonnummer finden. ---\n "
                         "\nDen Anfang eines Namens eingeben: ";
                 getline( cin, name);
                 if( !name.empty())
                 {
                   myFriends.print( name);
                   weiter();
                 }
                 break;

      case 'H':  myFriends.getNewEntries();      // Hinzufgen
                 break;

      case 'L':                                  // Lschen
                 cout << "\n--- Telefoneintrag loeschen. ---\n"
                         "\nDen vollstndigen Namen eingeben: ";
                 getline( cin, name);
                 if( !name.empty())
                 {
                   if( !myFriends.erase( name))
                       cout << name << " nicht gefunden!" << endl;
                   else
                       cout << "Eintrag fuer " << name << " geloescht!"
                            << endl;
                   weiter();
                 }
                 break;

      case 'O':                                  // Datei ffnen
                 if( myFriends.isDirty()  &&  askForSave() == 'J')
                     myFriends.save();

                 if( myFriends.load())
                    cout << "Telfon-Liste aus der Datei "
                         << myFriends.getFilename() << " eingelesen!"
                         << endl;
                 else
                    cerr << "Telfon-Liste wurde nicht eingelesen!" << endl;

                 weiter();
                 break;

      case 'U':                                  // Speichern unter ...
                 if( myFriends.saveAs())
                    cout << "Telfon-Liste in der Datei "
                         << myFriends.getFilename() << " gespeichert!"
                         << endl;
                 else
                    cerr << "Telfon-Liste wurde nicht gespeichert!" << endl;

                 weiter();
                 break;

      case 'S':  if( myFriends.save())           // Speichern
                    cout << "Telefon-Liste in der Datei "
                         << myFriends.getFilename() << " gespeichert!"
                         << endl;
                 else
                    cerr << "Telefon-Liste wurde nicht gespeichert!" << endl;

                 weiter();
                 break;


      case 'B':                                  // Beenden
                 if( myFriends.isDirty()  &&  askForSave() == 'J')
                     myFriends.save();
                 cls();
                 break;
    }
  } // Ende while

  return 0;
}

int menu()
{
   static char menuStr[] =
   "\n             A = Anzeigen alle Eintraege"
   "\n             F = Finden einer Telefonnummer"
   "\n             H = Hinzufuegen eines Eintrags"
   "\n             L = Loeschen eines Eintrags"
   "\n             -------------------------------------"
   "\n             O = Oeffnen einer Datei"
   "\n             S = Speichern "
   "\n             U = Speichern unter ..."
   "\n             -------------------------------------"
   "\n             B = Beenden des Programms"
 "\n\n Ihre Wahl:  ";

   cls();
   cout << header << menuStr;

   char wahl;
   if( !(cin >> wahl))
      wahl = 'B';
   else
      wahl = toupper(wahl);

   cin.ignore( LLONG_MAX, '\n');   // Rest der Zeile loeschen.
   return wahl;
}

char askForSave()
{
   char c;
   cout << "Soll die aktuelle Telefonliste gespeichert werden (j/n)? ";
   do
   {
       cin.get(c);
       c = toupper(c);
   }
   while( c != 'J'  &&  c != 'N');

   cin.ignore( LLONG_MAX, '\n');   // Rest der Zeile loeschen.
   return c;
}
