// ----------------------------------------------------------
// Fraction.h
// Eine numerische Klasse zur Reprsentierung von Brchen
// ----------------------------------------------------------
#ifndef FRACTION_H
#define FRACTION_H

#include <iostream>
//#include <compare>       // C++20: Fr Operator <=>
using namespace std;

class Fraction
{
  private:
   long zaehler, nenner;

  public:
   Fraction(long z = 0, long n = 1);

   Fraction operator-() const
   {
      return Fraction(-zaehler, nenner);
   }

   Fraction& operator+=(const Fraction& a)
   {
      zaehler = a.zaehler * nenner + zaehler * a.nenner;
      nenner *= a.nenner;
      return *this;
   }

   Fraction& operator-=(const Fraction& a)
   {
      *this += (-a);
      return *this;
   }

   Fraction& operator++()
   {
      zaehler += nenner;
      return *this;
   }

   Fraction& operator--()
   {
      zaehler -= nenner;
      return *this;
   }

   friend Fraction operator+ (const Fraction&, const Fraction& );
   friend Fraction operator- (const Fraction&, const Fraction& );
   friend Fraction operator* (const Fraction&, const Fraction&);
   friend Fraction operator/ (const Fraction&, const Fraction&);

   friend ostream& operator<< (ostream& os, const Fraction& a);
   friend istream& operator>> (istream& is, Fraction& a);

   // Vergleiche (Zusatzaufgabe)
   friend bool operator<(const Fraction&, const Fraction&);
// Alternative: Operator <=> statt <  (C++20)
// friend weak_ordering operator<=>(const Fraction&, const Fraction&);
   friend bool operator==(const Fraction&, const Fraction&);
};

#endif  // FRACTION_H
