// --------------------------------------------------------
// Fraction.h (Kapitel 19)
// Eine numerische Klasse zur Darstellung von Brchen.
// Erweiterung der Klasse Fraction aus Kapitel 18, Aufgabe 2,
// mit Konvertierungen Fraction <--> double
// und Krzen von Brchen.
// --------------------------------------------------------
#ifndef FRACTION_H
#define FRACTION_H

#include <iostream>
using namespace std;

class Fraction
{
  private:
   long zaehler, nenner;

  public:
   Fraction(long z, long n);
   Fraction(double x);              // double-Konstruktor

   // Default- long- und int-Konstruktor:
   Fraction(long z=0) : zaehler(z), nenner(1) {}
   Fraction(int z) : zaehler(z), nenner(1) {}

   void kuerzen();

   operator double()                // Fraction -> double
   {
       return (double)zaehler / (double)nenner;
   }
   
   Fraction operator-() const
   {
      return Fraction(-zaehler, nenner);
   }

   Fraction& operator+=(const Fraction& a)
   {
      zaehler = a.zaehler * nenner + zaehler * a.nenner;
      nenner *= a.nenner;
      kuerzen();
      return *this;
   }

   Fraction& operator-=(const Fraction& a)
   {
      *this += (-a);
      kuerzen();
      return *this;
   }

   Fraction& operator++()
   {
      zaehler += nenner;
      return *this;
   }

   Fraction& operator--()
   {
      zaehler -= nenner;
      return *this;
   }

   friend Fraction operator+ (const Fraction&, const Fraction& );
   friend Fraction operator- (const Fraction&, const Fraction& );
   friend Fraction operator* (const Fraction&, const Fraction&);
   friend Fraction operator/ (const Fraction&, const Fraction&);

   friend ostream& operator<< (ostream& os, const Fraction& a);
   friend istream& operator>> (istream& is, Fraction& a);
};

#endif  // FRACTION_H
