// ----------------------------------------------------
// Splice.cpp 
// Implementierung des Splice-Algorithmus.
// ----------------------------------------------------

#include <iostream>
#include <iomanip>
#include <cstdlib>          // Fr srand() und rand()
#include <ctime>            // und time().
using namespace std;

// Prototyp:
int *splice( int v1[], int len1, int v2[], int len2, int pos);

int main()
{
    cout << "\n  * * *  splice-Funktion testen  * * *\n"
         << endl;

    int i, len1 = 10, len2 = 5;
    int *a1 = new int[len1],
        *a2 = new int[len2];

    srand( (unsigned)time(NULL));  // Zufallsgenerator mit
                                   // akt. Zeit initialisieren.

    for( i=0; i < len1; ++i)       // Vektoren initialisieren. 
       a1[i] = rand();             // Positive Zufallszahlen.

    for( i=0; i < len2; ++i) 
       a2[i] = -rand();            // Nur negative Zahlen.

   // Vektoren ausgeben:
   cout << "1. Vektor: " << endl;
   for( i = 0; i < len1; ++i)
      cout << setw(8) << a1[i];
   cout << endl;

   cout << "2. Vektor: " << endl;
   for( i = 0; i < len2; ++i)
      cout << setw(8) << a2[i];
   cout << endl;

   cout << "\n Bei welcher Position soll der 2. Vektor"
           "\n im 1. Vektor eingefuegt werden?"
           "\n Moegliche Positionen: 0, 1, ..., " << len1
        << " : ";

   int pos;  cin >> pos;

   int *a3, len3 = len1 + len2;
   a3 = splice( a1, len1, a2, len2, pos);
   
   if( a3 == NULL)
      cerr << "\n Ungueltige Position!\n" << endl;
   else
   {
      cout << " Der neue verschweisste Vektor: " << endl;
      for( i = 0; i < len3; ++i)
         cout << setw(8) << a3[i];
      cout << endl;
   }
   delete[] a1;   delete[] a2;   delete[] a3;
   return 0;
}

// ---------------------------------------------------------
//  Die Funktion splice() fgt in v1 den Vektor v2 
//  ab der Position pos ein.

int *splice( int v1[], int len1, int v2[], int len2, int pos)
{
   if( pos < 0  ||  pos > len1)
      return NULL;
    
   int i = 0, i1 = 0, i2 = 0;

   int *v = new int[len1+len2];
   
   for( i = 0, i1 = 0; i1 < pos;  ++i, ++i1)  // 1. Teil
       v[i] = v1[i1];

   for( i2 = 0; i2 < len2;  ++i, ++i2)        // 2. Teil
       v[i] = v2[i2];
  
   for(  ; i1 < len1;  ++i, ++i1)             // 3. Teil
       v[i] = v1[i1];

   return v;
}
