// FloatV_t.cpp: 
// Die Klasse FloatVek testen.
// -----------------------------------------------------
#include "FloatVek.h"
#include <iostream>
#include <iomanip>
using namespace std;

int main()
{
    FloatVek v(10);        // Vektor v fr 10 float-Werte
    FloatVek w(20, 1.0F);  // Vektor w fr 20 float-Werte
                           // mit 1.0 initialisieren.

    cout << "Aktuelle Anzahl Elemente in v: " 
         << v.length() << endl;

    cout << "Aktuelle Anzahl Elemente in w: " 
         << w.length() << endl;

    float a = -2.0F; 
    for( ; a < 2 ; a += 0.7F)
       if( !v.append(a))
          break;

    cout << "\nDie Vektorelemente von v nach dem Anhaengen:"
         << endl;
    int i;                 // Ein Index.
    for( i=0; i < v.length(); ++i)
        cout << setw(6) << v[i];
    cout << endl;

    w.remove(3);           // Element auf Position 3 lschen.
    w.append(10.0F);       // Neues Element hinzufgen.
    if( !w.append(20.0F))  // Und nochmal!
        cerr << "\nVektor w ist voll!" << endl;

    const FloatVek cv(v);        // konstantes Objekt mit
                                 // Kopier-Konstruktor.

    cout << "\nKopie von v wurde angelegt.\n";
    cout << "\nHier die Vektorelemente der Kopie:" << endl;
    for(i=0; i < cv.length(); i++)
        cout << setw(6) << cv[i];
    cout << endl;

    v = w;
    cout << "\nZuweisung v = w erfolgt.\n";
    cout << "\nDie Elemente nach der Zuweisung:" << endl;
    for(i=0; i < v.length(); i++)
        cout << setw(4) << v[i];
    cout << endl;

    return 0;
}
