// cast_t.cpp
// Zum Testen von dynamischen Casts in Klassenhierarchien.
// ---------------------------------------------------------
#include "kfz.h"

bool inspect( Pkw* ),           // Inspektion verschiedener
     inspect( Lkw* );           // Fahrzeugtypen.

bool distribute(Kfz* kfzPtr);   // Fahrzeuge zur Inspektion
                                // verteilen.
int main()
{
    Kfz* kfzPtr = new Pkw("520i", true, 3265, "BMW");

    Pkw* pkwPtr = dynamic_cast<Pkw*>(kfzPtr);
    if( pkwPtr != NULL)                         // ok?
    {
     cout << "\nNach dem Down-Cast des Zeigers: " << endl;
     pkwPtr->display();
    }

    Pkw cabrio("190 SL", true, 9154, "Mercedes Benz");
    Kfz& r_kfz = cabrio;

    Pkw& r_pkw = dynamic_cast<Pkw&>(r_kfz);
    // ok? Lst Exception aus, falls nicht ok.

    cout << "\nNach dem Down-Cast der Referenz: " << endl;
    r_pkw.display();
    cin.get();

    Lkw* lkwPtr = new Lkw(8, 7.5, 5437, "Volvo");
    distribute(kfzPtr);
    distribute(lkwPtr);

    return 0;
}

bool distribute( Kfz* kfzPtr)
{
   Pkw* pkwPtr = dynamic_cast<Pkw*>(kfzPtr);
   if( pkwPtr != NULL)
      return inspect( pkwPtr);

   Lkw* lkwPtr = dynamic_cast<Lkw*>(kfzPtr);
   if( lkwPtr != NULL)
      return inspect( lkwPtr);

   return false;
}

bool inspect(Pkw* pkwPtr)
{
    cout << "\nIch teste einen Pkw!" << endl;
    cout << "\nHier ist er:";
    pkwPtr->display();
    return true;
}

bool inspect(Lkw* lkwPtr)
{
    cout << "\nIch teste einen Lkw!" << endl;
    cout << "\nHier ist er:";
    lkwPtr->display();
    return true;
}
