// ------------------------------------------------------
// kombi.h : Definition der Klasse Transporter und
//           der mehrfach abgeleiteten Klasse Kombi
// ------------------------------------------------------
#ifndef KOMBI_H_
#define KOMBI_H_

#include "kfz.h"

class Transporter : public virtual Kfz
{
  private:
    double last;

  public:
    Transporter(long n=0L, const string& hst="", double l=0.0)
    : Kfz(n,hst)
    {
        setLast(l);
    }

    void setLast(double l)
    {
        if(l < 0)         last = 0;
        else if(l > 750)  last = 750;
        else              last = l;
    }

    double getLast() const { return last; }

    void display() const
    {
       cout << "Last:         "
            << last  << " kg" << endl;
    }
};

class Kombi : public Pkw, public Transporter
{
   private:
      int anz;          // Anzahl Sitzpltze
   public:
      Kombi(const string& tp="ohne Typ", bool sb=false, long n=0L,
            const string& hst="ohne Herst", double l=0.0, int z = 1)
      : Kfz(n, hst), Pkw(tp, sb), Transporter(n,hst,l), anz(z)
      { }

      void display() const
      {
         Pkw::display();
         Transporter::display();
         cout << "Sitzplaetze:  " << anz << endl;
      }
};
#endif
