// ----------------------------------------------
// mulmap_t.cpp:    Zum Testen von Multimaps
// ----------------------------------------------
#include <map>
#include <string>
#include <iostream>
using namespace std;

bool oddKey(pair<int, string> p)   // Wahr, wenn der Schlssel
{ return p.first % 2 != 0; }       // ungerade ist.

int main()
{
    // Multimap anlegen und mit zwei Elementen initialisieren:
    multimap<int, string>  m = { {7,"Uwe"}, {4,"Edith"} };

    // Einfgen:
    m.insert(pair<int, string>(1, "Dina"));
    m.insert(pair(1, "Lino"));   // Automatische Ermittlung von
                                 // Template-Argumenten (C++17).

    cout << "Hier die Multimap: " << endl;
    for( auto& el : m)
        cout << el.first << "  " << el.second << endl;
    cout << endl;

    auto pos = m.find(3);         // Paar zum Schlssel suchen
    if( pos != m.end())
       cout << pos->first << "  " << pos->second << endl;

    int key = 1;                  // Anzahl Objekte bestimmen
    cout << "Zum Schluessel " << key << " gibt es "
         <<  m.count(key) << " Objekte\n" << endl;

    // erase_if() verwenden (C++20):
/*
    cout << "Elemente mit ungeradem Schluessel loeschen.\n";
    auto anz = erase_if(m, oddKey);
    cout << anz << " Elemente geloescht!" << endl;
*/
    return 0;
}
