// unorderedMap.cpp: Zum Testen von ungeordneten Maps
// -----------------------------------------------------
#include <unordered_map>
#include <string>
#include <iostream>
using namespace std;

typedef unordered_map<string, unsigned long> UNORDERED_MAP;

int main()
{
    UNORDERED_MAP  m;            // Ungeordnete Map anlegen.
                                 // Einfgen:
    m.insert(pair<string, unsigned long>("Mayer", 1234567)); 
                                 // Auch mglich:
    m["Mahler"] = 7654321UL;
    m["Mandel"] = 1357642UL;

    for(auto& el : m)
        cout << "Bucketnr. " << m.bucket(el.first) << ":  "
             << el.first << "  " << el.second << endl;

    cout << "\nAnzahl Buckets:  "      << m.bucket_count() 
         << "\nAnzahl Objekte:  "      << m.size() 
         << "\nBelegungsfaktor: "      << m.load_factor()
         << "\nMax. Belegungsfaktor: " << m.max_load_factor() << endl;

    return 0;
}
