// ---------------------------------------------------
// parity_t.cpp: Definition der Funktion parity(),
//               welche die Paritt einer unsigned-Zahl
//               berechnet. 
// Return-Wert: 0, falls die Anzahl der 1-Bits gerade,
//              1 sonst.
// ---------------------------------------------------

unsigned int bit0( unsigned int x ) 
{ 
   return (x & 1); 
}

int parity( unsigned int n)
{
   unsigned int par = 0;
   for( ; n != 0; n >>=1 )
     par ^= bit0(n);
   return par;
}

// ---------------------------------------------------
// Funktion parity() testen.

#include <iostream>
using namespace std;

int main()
{
    unsigned int x;       

    cout << "Bitte eine positive Zahl eingeben:  ";
    cin >> x;
    
    if( parity(x) != 0)
        cout << "Die Zahl " << x
             << " hat eine ungerade Anzahl Bits";
    else
        cout << "Die Zahl " << x
             << " hat eine gerade Anzahl Bits";
    cout << endl;

    return 0;
}
