// ------------------------------------------------------
// bits_t.cpp
// Programm zur Demonstration der Bitoperatoren.
// ------------------------------------------------------
#include <iostream>
#include <iomanip>
using namespace std;

void putbits( unsigned int n);  // Prototyp von putbits() 

int main()               // Lernprogramm zu Bitoperatoren
{
   int  x, y, anzahl;
   char jn;

   do
   {
     cout << "\n\n     ******  BIT-OPERATOREN  ******\n";

     cout << "\nBitte geben Sie zwei ganze Zahlen ein.\n\n"
          << "1. Zahl --> ";
     cin >> x;

     cout << "2. Zahl --> ";
     cin >> y;

     cout << "\nDas Bitmuster von " 
          << setw(6) << x << " = x  :    ";
     putbits(x); 

     cout << "\nDas Bitmuster von " 
          << setw(6) << y << " = y  :    ";
     putbits(y); 

     cout << "\nDas Bitmuster von      x & y  :    "; 
     putbits(x&y);

     cout << "\nDas Bitmuster von      x | y  :    ";
     putbits(x|y); 

     cout << "\nDas Bitmuster von      x ^ y  :    ";
     putbits(x^y);

     cout << "\n\nUm wieviele Positionen soll x geshiftet werden?"
          << "\nAnzahl --> ";
     cin >> anzahl;

     if( anzahl < 0  ||  anzahl > 15)
     {
        cout << "Falsche Eingabe!"
             << " Es wird um eine Position geshiftet.\n";
        anzahl = 1;
     }
     cout << "\nDas Bitmuster von     x << " 
          << setw(2) << anzahl << " :    ";
     putbits( x << anzahl); 

     cout << "\nDas Bitmuster von     x >> "
          << setw(2) << anzahl << " :    ";
     putbits( x >> anzahl); 

     cout << "\nWiederholen (j/n)? ";

     cin >> jn; 
     while( (jn | 0x20) != 'j'  &&  jn != 'n')
       ;

   }while( jn == 'j');

   return 0;
}

void putbits( unsigned int n )      // Bitmuster von n ausgeben 
{                                   // (nur die unteren 16 Bits) 
   int i;

   for( i = 15; i >= 0 ; --i)
   {
      cout << (char)( ((n>>i) & 1) + '0'); // i-tes Bit ausgeben
      if( i % 4 == 0  &&  i > 0)           // und nach vier Bits 
         cout << ' ';                      // ein Blank.
   }
}
