// threadID.cpp
// Bestimmt die ID von Threads.
// --------------------------------------------------------
#include <thread>
#include <mutex>
#include <iostream>
using namespace std;

mutex mtx;
class ThreadID
{
  public:
    void operator()()
    {
      mtx.lock();
      cout << "\nAktiver Thread: " << this_thread::get_id(); 
      mtx.unlock();
    }
};

int main()
{
   ThreadID a;      thread t1(a), t2(a);

   mtx.lock();
   cout << "\nThread-ID von t1: " << t1.get_id();
   cout << "\nThread-ID von t2: " << t2.get_id();
   mtx.unlock();

   t1.detach();
   mtx.lock();
   cout << "\nThread von t1 getrennt.\nThread-ID von t1: "
        << t1.get_id();
   mtx.unlock();

   t2.join();   
   mtx.lock();
   cout << "\nNach dem Aufruf von join()."
        << "\nThread-ID von t2: " << t1.get_id() << endl;
   mtx.unlock();

   return 0;
}
/* Beispielausgabe:

Thread-ID von t1: 3520
Thread-ID von t2: 10096
Thread von t1 getrennt.
Thread-ID von t1: 0
Aktiver Thread: 10096
Aktiver Thread: 3520
Nach dem Aufruf von join().
Thread-ID von t2: 0

*/
