// search_count.cpp: Teilfolge suchen und bestimmte Elementen zaehlen.
// ------------------------------------------------------------------
#include <iostream>
#include <string>
#include <list>              // Definition des list-Templates 
#include <algorithm>         // Definition der Algorithmen-Templates
using namespace std;

void print( const string& s)
{  cout.width(8);  cout << left << s; }

struct Laenger
{  int cmp;
   Laenger(int val) : cmp(val) {}
   bool operator()(const string& s){ return (int)s.length() > cmp;}
};

int main()
{
    string suchFolge[] = { "Eva", "Hans", "Max" };  // Zum Suchen
    list<string> namen( suchFolge, suchFolge+3);    // Liste mit Namen
    // Weitere Namen hinzufgen:
    namen.push_back("Petra");  namen.push_front("Otto");
    // und nochmal die suchFolge anhngen
    namen.insert( namen.end(), suchFolge, suchFolge+3); 

    cout << "Liste der Namen:" << endl;   // Liste mit Namen anzeigen. 
    for_each( namen.begin(), namen.end(), print);
    cout << endl;

    // Die Namen zhlen, dle lnger als 3 Zeichen sind:
    int anzahl = (int)count_if( namen.begin(), namen.end(), Laenger(3) );
    cout << anzahl << " Namen sind laenger als 3 Zeichen." << endl;

    // Erstes Vorkommen einer Teilfolge suchen:
    list<string>::iterator i =                      // Ein Iterator.
       search( namen.begin(), namen.end(), suchFolge, suchFolge+3);
    if( i != namen.end()) {                         // Gefunden?
        cout << "\nListe ab gefundener Teilfolge: " << endl; 
        for_each( i, namen.end(), print);
        cout << endl;
    } 
    else cout << "\nTeilfolge nicht gefunden" << endl;

    return 0;
}
/*
Ausgabe:
Liste der Namen:
Otto    Eva     Hans    Max     Petra   Eva     Hans    Max
4 Namen sind laenger als 3 Zeichen.

Liste ab gefundener Teilfolge:
Eva     Hans    Max     Petra   Eva     Hans    Max
*/
