// streamIteratoren.cpp: Algorithmen mit Stream-Iteratoren aufrufen.
// Zeigt den Inhalt einer Datei mit Gleitpunktzahlen an.
// ---------------------------------------------------------------
#include <iostream>
#include <fstream>         // Die File-Stream-Klassen
#include <algorithm>       // Definition der Algorithmen-Templates
//#include <iterator>
using namespace std;

int main()
{
    char filename[] = "data.txt";           // Datei mit float-Werten
    ifstream inFile(filename);              // Filestream anlegen
    if( !inFile)
    {  cout << "Fehler beim Oeffnen der Datei " << filename << endl;
       return 1;
    }
    // Daten aus Datei lesen und auf cout ausgeben:
    copy( istream_iterator<float>(inFile),     // istream-Iterator
          istream_iterator<float>(),           // Iterator fr EOF
          ostream_iterator<float>(cout,"\n")); // ostream-Iterator

    if( !inFile.eof())
    {  cout << "Fehler beim Lesen der Datei " << filename << endl;
       return 2;
    }
    return 0;
}

/* Beispiel-Ausgabe:

11.1
2.2
33.3
-4.44
5.5

*/
