// polynom_t.cpp:     Klasse Polynom testen
// ----------------------------------------------------
#include "polynom.h"
#include <iostream>
using namespace std;

template<class T>
void printPolynom( const Polynom<T>& p)
{
   for( int i = 0; i <= p.grad(); ++i)
       cout << p[i] << " ";
    cout << endl;
}

int main()
{
    double a[3] = { 2.0, -3.0, 1.0 };
    Polynom<double> p1(a,2), p2(a,0);
    cout << "Die Koeffizienten der Polynome p1 und p2: " << endl;
    cout << "p1: "; printPolynom(p1);
    cout << "p2: "; printPolynom(p2);

    p2 += p1;
    cout << "Die Koeffizienten der Summe: " << endl;
    cout << "p2: "; printPolynom(p2);
    cout << "Grad des Polynoms: " << p2.grad() << endl;

    p2 = p1;                 // Zuweisung
    cout << "Die Koeffizienten nach der Zuweisung: " << endl;
    cout << "p2: "; printPolynom(p2);

    cout << "Einige Funktionswerte: " << endl;
    cout << "p2(-1.0) = " << p2(-1.0) << endl;
    cout << "p2(1.0)  = " << p2(1.0) << endl;
    cout << "p2(1.5)  = " << p2(1.5) << endl;
    cout << "p2(2.0)  = " << p2(2.0) << endl;

    p2.resize(1);          // Polynom 1. Grades
    p2[0] = -1.0;
    p2[1] =  2.0;
    cout << "\nNach der Zuweisung neuer Koefizienten: " << endl;
    cout << "p2: "; printPolynom(p2);
    cout << "Grad des neuen Polynoms: " << p2.grad() << endl;

    Polynom<double> p = p1 * p2;
    cout << "Grad nach der Multiplikation p1 * p2: "
         << p.grad() << endl;
    cout << "Die Koeffizienten des Produktes: " << endl;
    cout << "    "; printPolynom(p);

    return 0;
}
