//--------------------------------------------------------------
// Ellipse.cpp
// Dieses Programm zeichnet eine Ellipse.
// Fr die Punkte (x,y) einer Ellipse mit dem Mittelpunkt (0,0),
// der Hauptachse A und der Nebenachse B gilt:
//    x = A*cos(t), y = B*sint(t)  fr  0 <= t <= 2*PI .
// -------------------------------------------------------------
// Fr die Bildschirmsteuerung werden Makros aus der Datei 
// myMakros.h verwendet. Diese Datei wird in der 1. Aufgabe 
// zu Kapitel 7 erstellt.
// -------------------------------------------------------------

#include <iostream>
#include <cmath>        // Prototypen von sin() und cos()
#include "myMakros.h"   // Definition der Makros aus Kapitel 7:
                        // CLS : Bildschirm lschen.
                        // LOCATE(z,s) : Cursor in Zeile z
                        // und Spalte s positionieren.
using namespace std;

const double PI = 3.1416;
const int Mx = 40,           // Der Punkt (Mx, My) ist der
          My = 12,           // Mittelpunkt der Ellipse.
          A  = 25,           // Lnge der Hauptachse,
          B  = 10;           // Lnge der Nebenachse.

int main()
{
    int x,y;     // ganzzahlige Bildschirmkoordinaten.
                 // x-Kordinate = Spalte, y-Kordinate = Zeile.
    CLS;
                   // 0 <= t <= PI/2 ist ein 1/4-Kreis:
    for( double t = 0.0 ; t <= PI/2 ; t += PI/80)
    {
       // Berechnung der Punktkoordinaten.
       // Konvertierung in int notwendig, da x und y ganzzahlig.
       x = (int) (A * cos(t) + 0.5);
       y = (int) (B * sin(t) + 0.5);

       LOCATE( y+My, x+Mx);  cout << '*';
       LOCATE( y+My,-x+Mx);  cout << '*';
       LOCATE(-y+My, x+Mx);  cout << '*';
       LOCATE(-y+My,-x+Mx);  cout << '*';
    }
    LOCATE(23,1);
    return 0;
}
