// -----------------------------------------------------
//  sinKurve.cpp
//  Ausgabe der Sinus-Kurve
//  --------------------------------------------------
//  Verwendung der Makros CLS() und LOCATE(z,s) 
//  aus myMakros.h fr die Bildschirmsteuerung.
// -----------------------------------------------------

#include <iostream>
#include <cmath>                  // Prototyp von sin()
#include "myMakros.h"
using namespace std;

#define PI        3.1415926536
#define START     0.0            // Untergrenze
#define ENDE     (2.0 * PI)      // Obergrenze
#define PKT       64             // Anzahl Punkte der Kurve
#define SCHRITT  ((ENDE-START)/PKT)
#define xA        14             // Zeile  fr x-Achse
#define yA        10             // Spalte fr y-Achse

int main()
{
    int  zeile, spalte;

    CLS;
    LOCATE(2,25);
    cout << "-------  Die Sinus-Kurve  -------";

    //    ---  Koordinaten-Kreuz zeichnen: ---

    LOCATE(xA,1);                               // x-Achse
    for( spalte = 1 ; spalte < 78  ; ++spalte)
    {
        cout << ((spalte - yA) % 8  ?  '-' : '+');
    }
    cout << '>';                                // Spitze
    LOCATE(xA-1, yA+64);  cout << "2PI  x";

    for( zeile = 5 ; zeile < 22 ; zeile +=2)    // y-Achse
    {
       LOCATE(zeile, yA);    cout << '|';
       LOCATE(zeile+1, yA);  cout << '+';
    }
    LOCATE( 4, yA);  cout << "\136 sin(x)";     // Spitze

    LOCATE( xA-8, yA+1);  cout << " 1";
    LOCATE( xA+8, yA+1);  cout << " -1";

    //     ---  Sinus-Kurve ausgeben:  ---

    int anfsp = yA,
        endsp = anfsp + PKT;

    for( spalte = anfsp;  spalte <= endsp;  ++spalte)
    {
       double x = double(spalte-yA) * SCHRITT;
       zeile = (int)(xA - 8 * sin(x) + 0.5);
       LOCATE( zeile, spalte);  cout << '*';
    }

    LOCATE(23,1);        // Cursor unter die Kurve setzen.
    return 0;
}
/*

                        -------  Die Sinus-Kurve  -------

         ^ sin(x)
         |
         + 1          *******
         |         ***       ***
         +       **             **
         |      *                 *
         +    **                   **
         |   *                       *
         + **                         **
         |*                             *                               2PI  x
-+-------*-------+-------+-------+-------*-------+-------+-------+-------*--->
         |                                *                             *
         +                                 **                         **
         |                                   *                       *
         +                                    **                   **
         |                                      *                 *
         +                                       **             **
         |                                         ***       ***
         + -1                                         *******

*/
