// -----------------------------------------------------
// Passw2.cpp
// Definition der Funktionen getPassword(), zeitdiff()
// und changePassword() zur berprfung und nderung
// eines Passwortes.
// -----------------------------------------------------
#include <iostream>
#include <iomanip>
#include <string>
#include <ctime>
using namespace std;

static long zeitdiff(void);               // Prototyp
static string geheimwort = "gast";        // Passwort 
static long  maxanzahl = 3, maxzeit = 60; // Limits

static long zeitdiff(void);

bool getPassword()  // Passwort einlesen und berprfen.
{               // Return-Wert: true, falls Passwort ok.
   bool ok_flag = false;         // Fr die Rckgabe 
   string wort;                  // Fr die Eingabe 
   int anzahl = 0, zeit = 0;

   zeitdiff();                   // Die Stopuhr starten
   while( ok_flag != true && 
          ++anzahl <= maxanzahl) // Anzahl Versuche 
   {
      cout << "\n\nGeben Sie das Passwort ein:  ";
      cin >> setw(20) >> wort;
      cin.ignore(LLONG_MAX,'\n');  // Rest der Zeile lschen

      zeit += zeitdiff();
      if( zeit >= maxzeit )        // Im Zeitlimit?
         break;                    // nein!
      if( wort != geheimwort)
         cout << "Passwort ungueltig!" << endl;
      else 
         ok_flag = true;           // Erlaubnis geben
    }
    return ok_flag;                // Ergebnis
}

// Lokale Hilfsfunktion zeitdiff() --> static definieren
static long zeitdiff()       // Liefert die Anzahl Sekunden
{                            // seit dem letzten Aufruf.
    static time_t  sek = 0;    // Zeit vom letzten Aufruf.
    time_t  altsek = sek;      // Alte Zeit merken.
    time( &sek);               // Neue Zeit lesen.
    return (long)sek - (long)altsek;   // Differenz zurckgeben.
}

bool changePassword()        // Passwort ndern.
{                            // Return-Wert: true, 
                             // falls Passwort gendert.
   string wort1,wort2;          // Fr die Eingabe 

   // Neues Passwort einlesen

   cout << "\nNeues Passwort eingeben (2 bis 20 Zeichen): ";
   cin >> setw(20) >> wort1;
   cin.ignore(LLONG_MAX,'\n');    // Rest der Zeile lschen

   if( wort1.size() > 1)
   {
      cout << "\nPasswort nochmal eingeben: ";
      cin >> setw(20) >> wort2;
      cin.ignore(LLONG_MAX,'\n'); // Rest der Zeile lschen

      if( wort1 == wort2)         // Passwort besttigt?
      {                           // Ja! 
          geheimwort = wort1;
          return true;
      }
   }
   return false;                  // Kein neues Passwort
}

