// -----------------------------------------------------
//  Password.cpp
//  Es werden die Funktionen getPassword() und
//  changePassword() getestet.
//
//  Nach richtiger Eingabe des Passwortes ( hchstens 
//  drei Versuche innerhalb von 60 Sekunden) kann das 
//  Passwort gender werden.
// -------------------------------------------------------
//  Statt der ANSI-Bildschirmsteuerzeichen werden hier
//  die Funktionen der Windows-API verwendet.
// -------------------------------------------------------

#include <iostream>
#include <iomanip>
#include <string>
#include <cctype>
using namespace std;

#include "..\..\console\console.h"     // fuer cls() 

bool getPassword(void);             // Passwort einlesen .
bool changePassword(void);          // Passwort ndern.

inline void weiter()
{
   cout << "\n\nWeiter mit der Return-Taste! ";
   while( cin.get() != '\n')
       ;
}

inline char getYesOrNo()      // Zeichen J oder N einlesen  
{
   char c = 0;
   do
   {
     cin.get(c);
     c = toupper(c);    // Auch Kleinbuchstaben zulassen.
   }
   while( c != 'J'  && c != 'N');
   cin.ignore(LLONG_MAX,'\n');    // Rest der Eingabe lschen

   return c; 
}

static string header =
"\n\n      ****  Passwort-Handling testen  ****\n\n";

static string menu =
"\n\n              B = Buchung durchfuehren"
"\n\n              E = Ende des Programms"
"\n\n Ihre Wahl:   ";

int main()
{
   char wahl = 0;

   while( wahl != 'E')
   {
     cls();
     cout << header << menu;        // Header und Men

     cin.get(wahl);   wahl = toupper(wahl);
     cin.ignore(LLONG_MAX,'\n');    // Rest der Eingabe lschen

     cls();
     cout << header << endl;

     switch( wahl)
     {
       case 'B':
         if( !getPassword() )
         {
            cout << "Keine Berechtigung!" << endl;
            weiter();
         }
         else
         {
            cout << "Herzlich willkommen!\n\n"
                 << "Wollen Sie das Passwort aendern? (j/n)";
            if( getYesOrNo() == 'J')
            {
              if( changePassword() )
                cout << "Passwort geaendert!" << endl;
              else 
                cout << "Passwort unveraendert!" << endl;
              weiter();
            }

            // Hier folgen die Anweisungen fr die Buchung

         }
         break;

       case 'E':
         cls();  cout << "\n    Bye Bye!" << endl;
         break;
     }
   } // Ende while

   return 0;
}

