// Ref3.cpp 
// Zeigt die Verwendung von Referenzen als Ergebnistyp.
// --------------------------------------------------

#include <iostream>
#include <string>
using namespace std;

double& refMin( double&, double&);  // Referenz auf Minimum
                                    // zurckgeben.
int main()
{
   double x1 = 1.1,
          x2 = x1 + 0.5,
          y;

   y = refMin( x1, x2);             // Minimum an y zuweisen.
   cout << "x1 = " << x1 << "     "
        << "x2 = " << x2 << endl;
   cout << "Minimum: " << y  << endl;

   ++refMin( x1, x2);               // ++x1, da x1 das Minimum
   cout << "x1 = " << x1 << "     "      // x1 = 2.1
        << "x2 = " << x2 << endl;        // x2 = 1.6

   ++refMin( x1, x2);               // ++x2, da jetzt x2 das
                                    // Minimum ist.
   cout << "x1 = " << x1 << "     "      // x1 = 2.1
        << "x2 = " << x2 << endl;        // x2 = 2.6

   refMin( x1, x2) = 10.1;          // x1 = 10.1, da jetzt x1
                                    // das Minimum ist.
   cout << "x1 = " << x1 << "     "      // x1 = 10.1
        << "x2 = " << x2 << endl;        // x2 = 2.6
   
   refMin( x1, x2) += 5.0;          // x2 += 5.0, da jetzt x2
                                    // das Minimum ist.
   cout << "x1 = " << x1 << "     "      // x1 = 10.1
        << "x2 = " << x2 << endl;        // x2 = 7.6
   return 0;
}

double& refMin( double& a, double& b)  // Referenz auf
{                                      // das Minimum
    return a <= b ? a : b;             // zurckgeben.
}
