// unions.cpp 
// Eine Union definieren und verwenden.
// ---------------------------------------------------

#include <iostream>
using namespace std;

union WordByte
{
  private:
    unsigned short w;     // 16-Bit
    unsigned char b[2];   // zwei Bytes: b[0], b[1]

  public:
    unsigned short& word()    { return w; }
    unsigned char&  lowByte() { return b[0]; }
    unsigned char&  highByte(){ return b[1]; }
};

int main()
{
    WordByte wb;

    wb.word() = 256;

    cout << "\nword:     " << (int)wb.word();

    cout << "\nLowByte:  " << (int)wb.lowByte()
         << "\nHighByte: " << (int)wb.highByte() << endl;

    return 0;
}

/*
Ausgabe:

  word:     256
  LowByte:  0
  HighByte: 1
*/
