// konto.cpp 
// Definition der Konto-Methoden init() und display().
// ---------------------------------------------------

#include "konto.h"         // Definition der Klasse

#include <iostream>
#include <iomanip>
using namespace std;

// Definition der Konstruktoren:

Konto::Konto( const string& k_name, unsigned long k_nr,
             double k_stand)
{
   name  = k_name;
   nr    = k_nr;
   stand = k_stand;
}

Konto::Konto( const string& k_name )
{
   name = k_name;
   nr = 1111111;  stand = 0.0;
}

// Die Methode init() kopiert die begebenen Argumente
// in die privaten Elemente der Klasse.

bool Konto::init(const string& i_name,
                 unsigned long i_nr,
                 double        i_stand)
{
   if( i_name.size() < 1)     // Kein leerer Name
     return false;

   name  = i_name;
   nr    = i_nr;
   stand = i_stand;

   return true;
}

// Die Methode display() zeigt die privaten
// Daten am Bildschirm an.
void Konto::display()
{
   cout << fixed << setprecision(2) 
        << "--------------------------------------\n"
        << "Kontoinhaber:  " << name  << '\n'
        << "Kontonummer:   " << nr    << '\n'
        << "Kontostand:    " << stand << '\n'
        << "--------------------------------------\n"
        << endl;
}
