// ---------------------------------------------------
// artikel.h 
// Definition einer einfachen Klasse Artikel.
// ---------------------------------------------------
#ifndef ARTIKEL_H
#define ARTIKEL_H

#include <string>
using namespace std;

class Artikel
{
   private: 
     long nr;                // Artikelnummer
     string name;            // Artikelname
     double vk;              // Verkaufspreis

   public:
     Artikel( long nr=0, const string& name="noname",
              double vk=0.0);
     ~Artikel();
     void print();

     const string& getName() const { return name; }
     long          getNr()   const { return nr; }
     double        getVK()   const { return vk; }
     
     bool setName( const string& s)
     {
        if( s.size() < 1)      // Kein leerer Name
          return false;
        name = s;
        return true; 
     }
     void setNr( long n) { nr = n; }
     void setVK(double v)
     {                         // Kein negativer Preis
         vk = v > 0.0 ? v : 0.0;  
     }
};

#endif   // ARTIKEL_H
