// -------------------------------------------------------
// mitglied.h 
// Definition der Klasse Mitglied mit konstantem Element.
// -------------------------------------------------------
#ifndef MITGLIED_H
#define MITGLIED_H

#include "datum.h"
#include <string>
using namespace std;

class Mitglied
{
   private: 
     int nr;                 // Mitgliedsnummer
     string name;            // Name
     const Datum geb;        // Geburtsdatum
     // ... weitere Daten

     static Mitglied *ptrVorstand;  // Zeiger auf Vorstand,
                                    // NULL = kein Vorstand.
   public:
     Mitglied( long k_nr, const string& k_name, const Datum& k_geb)
     : nr(k_nr), geb(k_geb)
     {
         if( !setName(k_name))  name = "Unbekannt";
     }

     Mitglied( long k_nr, const string& k_name,
               int tag, int monat, int jahr)
     : nr(k_nr), geb(tag,monat,jahr)
     {
         if( !setName(k_name))  name = "Unbekannt";
     }

     int           getNr()    const { return nr; }
     const string& getName()  const { return name; }
     const Datum&  getGeburtstag() const { return geb; }
     
     void setNr( int n) { nr = n; }
     bool setName( const string& s)
     {
        if( s.size() < 1)      // Kein leerer Name
          return false;
        name = s;
        return true; 
     }
     void display() const;

     // statische Methoden:
     static Mitglied* getVorstand()
     {
        return ptrVorstand;
     }
     static void setVorstand( Mitglied* ptrMitgl) 
     {
        ptrVorstand = ptrMitgl;
     }
};

#endif   // MITGLIED_H
