// -----------------------------------------------------
// Ampel_t.cpp
// Die Klasse Ampel mit enum-Konstanten verwenden.
// -----------------------------------------------------

#include "Ampel.h"       // Definition der Klasse Ampel
#include <iostream>
#include <ctime>
using namespace std;

inline void warten( int sek)
{
   time_t ende = time(NULL) + sek;
   while( time(NULL) < ende)
       ;
}
// Alternative unter Windows:
// #include <windows.h>
// inline void warten( int sek)
// {
//    Sleep( 1000 * sek);
// }

Ampel A1, A2;

enum { gruenZeit1 = 10 , gelbZeit1 = 1,
       gruenZeit2 = 14 , gelbZeit2 = 2  };

int main() 
{
   cout << "Simulation zweier Ampeln!\n\n"
        << "Dieses Programm mit <Strg>+<C> beenden!\n"
        << endl;

   cout << "  1. Ampel     2. Ampel\n"
        << "---------------------------" << endl;
   while(true)
   {
      A1.setStatus( Ampel::rot);
      A2.setStatus( Ampel::gelb);   cout << endl;
      warten( gelbZeit2);
      cout << "             ";
      A2.setStatus( Ampel::gruen);  cout << endl;
      warten(gruenZeit2);
      cout << "             ";
      A2.setStatus( Ampel::gelb);   cout << endl;
      warten(gelbZeit2);

      A1.setStatus( Ampel::gelb);  
      A2.setStatus( Ampel::rot);    cout << endl;
      warten(gelbZeit1);
      A1.setStatus( Ampel::gruen);  cout << endl;
      warten(gruenZeit1);
      A1.setStatus( Ampel::gelb);  cout << endl;
      warten(gelbZeit1);
   }
   return 0;
}

/* Beispielausgabe:

Simulation zweier Ampeln!

Diese Programm mit <Strg>+<C> beenden!

  1. Ampel     2. Ampel
---------------------------
    ROT          GELB
                 GRUEN
                 GELB
    GELB         ROT
    GRUEN
    GELB
    ROT          GELB
                 GRUEN

*/