// -------------------------------------------------------
// TelList_t.cpp 
// Mit der Klasse TelList eine Telefon-Liste verwalten.
// -------------------------------------------------------
#include "telList.h"               // Definition der Klasse TelList
#include "..\..\console\console.h" // Windows Konsolenfunktionen
#include <iostream>
#include <string>
#include <cctype>
using namespace std;

inline void weiter()
{
   cout << "\n\nWeiter mit der Return-Taste! ";
   while( cin.get() != '\n')
       ;
}

int menu();              // Ein Kommando einlesen

char header[] =
"\n\n                *****  Telefon-Liste  *****\n\n";

TelList myFriends;       // Eine Telefon-Liste

int main()
{
  int aktion = 0;        // Kommando
  string name;           // Zum Einlesen eines Namens

  myFriends.append("Lustig, Peter", "0203-1234567");

  while( aktion != 'B')
  {
    aktion = menu();
    cls();
    cout << header << endl;

    switch( aktion)
    {
      case 'A':  myFriends.print();              // Alles anzeigen
                 weiter();
                 break;
      case 'F':                                  // Suchen
                 cout << "\n--- Telefonnummer finden. ---\n "
                         "\nDen Anfang eines Namens eingeben: "; 
                 getline( cin, name);
                 if( !name.empty())
                 {
                   myFriends.print( name);
                   weiter();
                 }
                 break;

      case 'H':  myFriends.getNewEntries();      // Hinzufgen
                 break;

      case 'L':                                  // Lschen 
                 cout << "\n--- Telefoneintrag loeschen. ---\n "
                         "\nDen vollstaendigen Namen eingeben: ";
                 getline( cin, name);
                 if( !name.empty())
                 {
                   if( !myFriends.erase( name))
                       cout << name << " nicht gefunden!" << endl;
                   else
                       cout << "Eintrag fuer " << name << " geloescht!" 
                            << endl;
                   weiter();
                 }
                 break;

      case 'B':  cls();                          // Beenden
                 break;
    }
  } // Ende while

  return 0;
}

int menu()
{
   static char menuStr[] =
   "\n\n             A = Anzeigen aller Eintraege"
   "\n\n             F = Finden einer Telefonnummer"
   "\n\n             H = Hinzufuegen eines Eintrags"
   "\n\n             L = Loeschen eines Eintrags"
   "\n\n             B = Beenden des Programms"
   "\n\n Ihre Wahl:  ";

   cls();
   cout << header << menuStr;

   char wahl;
   if( !(cin >> wahl))
      wahl = 'B';
   else
      wahl = toupper(wahl);
   cin.ignore( LLONG_MAX, '\n');  // Rest der Zeile lschen.
   return wahl;
}
