// -------------------------------------------------------
// selSort.cpp
// Implementierung des Selection-Sort-Algorithmus
// fr int-Vektoren.
// -------------------------------------------------------
#include <iostream>
#include <iomanip>
#include <cstdlib>           // Fr srand(), rand()
#include <ctime>             // Fr time()
using namespace std;

// Prototyp:
void selectionSort( int arr[], int len);

const int len = 200;
int intArr[len];            // int-Vektor

int main()
{
   cout << "\n     ***  Selection-Sort-Algorithmus  ***\n"
        << endl;

   // int-Vektor mit Zufallszahlen initialisieren:
   srand( (unsigned int)time(NULL));  // Zufallszahlen-
                                      // generator
                                      // initialisieren.
   for( int n=0; n < len; ++n) 
       intArr[n] = (rand() % 20000)-10000;

   // Zahlen sortieren
   selectionSort( intArr, len);

   // Zahlen ausgeben
   cout << "Die sortierten Zahlen:" << endl;

   for( int i = 0; i < len; ++i)
      cout << setw(8) << intArr[i];
   cout << endl;

   return 0;
}

inline void swap( int& a, int& b)
{
   int temp = a;  a = b;  b = temp;
}

// Indexversion:
/*
void selectionSort( int arr[], int len)
{
   register int j, mini;              // Indizes

   for( int i = 0;  i < len-1;  ++i)
   {
      mini = i;                       // Ab Index i das
      for( j = i+1; j < len; ++j)     // Minimum suchen.
         if( arr[mini] > arr[j])
             mini = j;

      swap( arr[i], arr[mini]);       // Tauschen.
   }
}
*/

// Zeigerversion:

void selectionSort( int *arr, int len)
{
   register int *p, *minp;     // Zeiger auf Vektorelemente,
   int *last = arr + len-1;    // Zeiger auf das letzte Elem.

   for( ; arr < last;  ++arr)
   {
      minp = arr;                     // Ab Position arr das
      for( p = arr+1; p <= last; ++p) // Minimum suchen.
         if( *minp > *p)
             minp = p;

      swap( *arr, *minp);             // Tauschen.
   }
}
