// --------------------------------------------------------
// matrix.cpp
// Zeilen- und Spaltensummen einer Matrix bilden.
// --------------------------------------------------------
#include <iostream>
#include <iomanip>
using namespace std;

// Definition und Initialisierung eines zweidimensionalen Vektors:

int matrix[3][5] = { { 25, 34, 26, 12,  8 },
                     { 19, 27, 24, 11,  4 },
                     {  6, 15, 35, 36, 18 } };

int zeilensumme[3];           // Fr die Summe ber die Zeilen  
int spaltensumme[5];          // Fr die Summe ber die Spalten 

// Prototyp der Funktion matrixsumme():
int matrixsumme( int arr2D[][5], int vlen, int zsum[], int spsum[]);

int main()
{
    cout << "Ein Test der Funktion matrixsumme().\n"
         << endl;

    // Summen berechnen:
    int gesamtsumme = 
        matrixsumme( matrix, 3, zeilensumme, spaltensumme);

    // Matrix und Summen ausgeben:
    cout << "Die Matrix mit den Zeilen- und Spaltensummen:\n"
         << endl;
    int i,j;
    for( i = 0 ; i < 3 ; ++i)         // Zeilen der Matrix mit 
    {                                 // Zeilensummen ausgeben.   
      for( j = 0 ; j < 5 ; ++j)
        cout << setw(8) << matrix[i][j];
      cout << " | " << setw(8) << zeilensumme[i] << endl;
    }
    cout << "  --------------------------------------------------"
         << endl;
    for( j = 0 ;  j < 5  ;  ++j )
      cout << setw(8) << spaltensumme[j];
    cout << " | " << setw(8) << gesamtsumme << endl;

    return 0;
}

// ----------------------------------------------------------
int matrixsumme( int v[][5], int len, int zsum[], int spsum[])
{
    int z, sp;                       // Zeilen- und Spaltenindex .

    for( z = 0 ; z < len ; ++z)      // Zeilensummen berechnen.
    {
       zsum[z] = 0;
       for( sp = 0 ; sp < 5 ; ++sp)
         zsum[z] += v[z][sp];
    }

    for(sp = 0 ; sp < 5 ; ++sp)      // Spaltensummen berechnen.
    {
       spsum[sp] = 0;
       for( z = 0 ; z < len ; ++z)
         spsum[sp] += v[z][sp];
    }

    // Gesamtsumme = Summe der Zeilensummen:
    int gesamt = 0;
    for( z = 0 ; z < len ; ++z)
         gesamt += zsum[z];
    return gesamt;
}
