// Liste.h 
// Definition der Klassen ListEl und List
// zur Darstellung einer einfach verketteten Liste.
// ----------------------------------------------------
#ifndef LISTE_H_
#define LISTE_H_

#include "Datum.h"
#include <iostream>
#include <iomanip>
using namespace std;

class ListEl 
{
  private:
    Datum  datum;         // Datum
    double betrag;        // Geldbetrag
    ListEl* next;         // Zeiger auf Nachfolger

  public:
    ListEl( Datum   d = Datum(1,1,1),
            double  b = 0.0, 
            ListEl* p = NULL)
            : datum(d), betrag(b), next(p) {}

    // Zugriffsmethoden
    const Datum& getDatum() const { return datum; }
    void setDatum()      // Setzt das aktuelle Datum
    {
       datum.setDatum();
    }
    bool setDatum( int tag, int monat, int jahr)
    {
       return setDatum( tag, monat, jahr);
    }
    
    double  getBetrag() const { return betrag; }
    void    setBetrag(double b) { betrag = b; }
    ListEl* getNext()  const { return next; }

    friend class Liste;
};

// Ausgabe eines Elementes
ostream& operator<<( ostream& os, const ListEl& le);

// ------------------------------------------------------
// Definition der Klasse Liste

class Liste
{
  private:
    ListEl* first, *last;
  public:
    Liste(){ first = last = NULL; }  // Konstruktor
    ~Liste();                        // Destruktor 

    // Zugriff auf erstes und letztes Element:
    ListEl* front() const { return first; } 
    ListEl* back()  const { return last; } 

    // Neues Element an die Liste anhngen:
    void pushBack(const Datum& d, double b);

    // Element am Anfang der Liste lschen.
    void popFront();
};

// Ausgabe der Liste
ostream& operator<<( ostream& os, const Liste& le);

#endif  // LISTE_H_