// -----------------------------------------------------
// FloatV_t.cpp
// Die Klasse FloatVek testen.
// -----------------------------------------------------

#include "FloatVek.h"
#include <iostream>
#include <iomanip>
using namespace std;

int main()
{
    FloatVek v(10);        // Vektor v fr 10 float-Werte
    FloatVek w(15, 1.0F);  // Vektor w fr 15 float-Werte
                           // mit 1.0 initialisieren.

    cout << "Aktuelle Anzahl Elemente in v: " 
         << v.length() << endl;
 
    cout << "Aktuelle Anzahl Elemente in w: " 
         << w.length() << endl;

    float a = -5.0F; 
    for( ; a < 6 ; a += 1.7F)
       v.append(a);

    v.append(v);                 // Auch mglich!

    cout << "\nDie Vektorelemente von v nach dem Anhaengen:"
         << endl;
    cout << setw(5) << v << endl;

    const FloatVek cv(v);        // konstantes Objekt mit
                                 // Kopier-Konstruktor.
    cout << "\nKopie von v wurde angelegt.\n";
    cout << "\nHier die Vektorelemente der Kopie:\n"
         << setw(5) << v << endl;

    w.remove(3);           // Element in Position 3 lschen.
    w.append(10.0F);       // Neues Element hinzufgen.
    w.append(20.0F);       // Und nochmal!

    v = w;
    cout << "\nZuweisung erfolgt.\n";
    cout << "\nDie Elemente nach der Zuweisung: \n"
         << setw(5) << v << endl;

    v.insert( cv, 0);
    cout << "\nDie Elemente nach dem Einfuegen der Kopie bei 0: \n"
         << setw(5) << v << endl;

    cout << "\n--- Weiter mit <Return> ---"; cin.get();

    // Vektoren addieren und Move-Konstruktor und Move-Zuweisung testen:
    FloatVek x(7, 1.0F);  // Vektor x der Lnge 7 mit 1.0 initialisieren.
    FloatVek y(v+x);      // Move-Konstruktor
    cout << "\nDie ersten 7 Elemente +1: \n"
         << setw(5) << y << endl;

    FloatVek z(0);        // "Leerer" Vektor.
    z = y + y;            // Move-Zuweisung.
    cout << "\n... und verdoppelt: \n"
         << setw(5) << z << endl;

    return 0;
}
