// -----------------------------------------------------
// v_destr.cpp
// Basis-Klasse mit virtuellem Destruktor.
// Ohne virtuellem Destruktor wrde nicht der Destrukor
// von Derived und damit auch nicht von Data ausgefhrt.
// -----------------------------------------------------
#define _CRT_SECURE_NO_WARNINGS    // fr VC und strcpy()
#include <iostream>
#include <cstring>
using namespace std;

class Base
{
  public:
   Base()
   {  cout << "Konstruktor der Klasse Basis\n"; }
   virtual ~Base()
   {  cout << "Destruktor der Klasse Basis\n"; }
};

class Data
{
  private:
    char *name;
  public:
    Data( const char *n)
    {
      cout << "Konstruktor der Klasse Data\n";
      name = new char[strlen(n)+1];
      strcpy(name, n);
    }
    ~Data()
    {
      cout << "Destruktor der Klasse Data fuer "
           << "Objekt: " << name << endl;
      delete [] name;
    }
};

class Derived : public Base
{
  private:
    Data data;
  public:
    Derived( const char *n)
    : data(n)
    {
      cout << "Konstruktor der Klasse Derived\n";
    }
    ~Derived()                // implizit virtuell
    {
      cout << "Destruktor der Klasse Derived\n";
    }
};

int main()
{
   Base *bPtr = new Derived("DEMO");
   cout << "\nAufruf des virtuellen Destruktors!\n";
   delete bPtr; 

   return 0;
}
