// --------------------------------------------------------
// kfz.h:   Definition der Basisklasse Kfz und
//          der abgeleiteten Klasse Pkw und Lkw
// --------------------------------------------------------
#ifndef KFZ_H_
#define KFZ_H_

#include <iostream>
#include <string>
using namespace std;

class Kfz
{
  private:
     long   nr;
     string hersteller;

  public:
     Kfz( long n = 0L, const string& herst = "");
     virtual ~Kfz() {}              // Virtueller Destruktor.

     // Zugriffsmethoden:
     long  getNr(void) const { return nr; }
     void  setNr( long n ) { nr = n; }

     const string& getHerst() const { return hersteller; }
     void  setHerst(const string& h){ hersteller = h; }

     virtual void display() const;   // Fahrzeug anzeigen
};

class Pkw : public Kfz
{
   private:
     string pkwTyp;
     bool   schiebe;

   public:
     Pkw(const string& tp, bool sd,
         int n = 0 , const string& h = "");

     // Zugriffsmethoden:
     const string& getTyp( void ) const { return pkwTyp; }
     void  setTyp( const string s ) { pkwTyp = s; }

     bool  getSchiebe( void ) const { return schiebe; }
     void  setSchiebe( bool d ) { schiebe = d; }

     void  display( void ) const override;
};

class Lkw : public Kfz
{
  private:
     int    achsen;
     double tonnen;

  public:
     Lkw( int a, double t, int n, const string& hs);

     void   setAchsen( int l)  { achsen = l;}
     int    getAchsen() const  { return achsen; }
     void   setKapazitaet( double t) { tonnen = t;}
     double getKapazitaet() const    { return tonnen; }

     void display() const override;
};
#endif
