// -------------------------------------------------------
// fraction.cpp
// Definition der Methoden und friend-Funktionen.
// -------------------------------------------------------
#include "Fraction.h"

// Konstruktor:
Fraction::Fraction(long z, long n)
{
  if(n == 0)
     throw DivisionByZero(); 
 
  if( n < 0 ) z = -z, n = -n;
  zaehler = z;
  nenner  = n;
}

Fraction operator+(const Fraction& a, const Fraction& b)
{
   Fraction temp;
   temp.nenner = a.nenner * b.nenner;
   temp.zaehler = a.zaehler*b.nenner
                  + b.zaehler * a.nenner;
   return temp;
}

Fraction operator-(const Fraction& a, const Fraction& b )
{
   Fraction temp = a;   temp += (-b);
   return temp;
}

Fraction operator*(const Fraction& a, const Fraction& b )
{
   Fraction temp;
   temp.zaehler = a.zaehler * b.zaehler;
   temp.nenner  = a.nenner  * b.nenner;
   return temp;
}

Fraction operator/(const Fraction& a, const Fraction& b )
{
   if( b.zaehler == 0)
      throw Fraction::DivisionByZero();
    
   // a mit dem Kehrwert von b multiplizieren:
   Fraction temp; 
   temp.zaehler = a.zaehler * b.nenner;
   temp.nenner  = a.nenner  * b.zaehler;

   if( temp.nenner < 0 )
     temp.zaehler = -temp.zaehler,
     temp.nenner  = -temp.nenner;

   return temp;
}

ostream& operator<<(ostream& os, const Fraction& a)
{
   os << a.zaehler << "/" << a.nenner;
   return os;
}

istream& operator>>(istream& is, Fraction& a)
{
   long zaehler = 0, nenner = 0;
   cout << "Bruch eingeben:\n"
           "  Zaehler:      ";   is >> zaehler;
   is.clear();  is.ignore(LLONG_MAX,'\n');

   cout << "  Nenner != 0:  ";   is >> nenner;
   is.clear();  is.ignore(LLONG_MAX,'\n');

   if( nenner == 0)
   {
      cout << "\nFehler: Der Nenner ist 0\n"
           << "  Neuer Nenner != 0: ";
      is >> nenner;
      is.clear();  is.ignore(LLONG_MAX,'\n');
   }
   if( nenner == 0)
      throw Fraction::DivisionByZero();

   a = Fraction(zaehler, nenner);

   return is;
}
