// ---------------------------------------------------
// input.cpp:  Die Funktion input() liest Zeichen von 
//             der Tastatur und hngt '\0' an. Mit Back-
//             space kann die Eingabe gelscht werden.
// Argumente:  1. Zeiger auf den Eingabepuffer.
//             2. Anzahl maximal einzulesender Zeichen.
//             3. Die optionalen Argumente: Zeichen, mit
//                denen die Eingabe abgebrochen wird.
//                Diese Liste mu mit CR = '\r' enden!
// Return-Wert: Zeichen, mit dem das Einlesen abbricht.
// ---------------------------------------------------

#include <stdarg.h>
#include <conio.h>     // Fr _getch() und _putch()

int input(char *puffer, int max,... )
{
  int c, breakc;  // Aktuelles Zeichen, Abbruchzeichen
  int nc = 0;     // Anzahl eingelesener Zeichen      
  va_list argp;   // Zeiger auf die weiteren Argumente
  
  while(true)
  {
    *puffer = '\0';
    if( ( c = _getch()) == 0)   // Zeichen einlesen.
       c = _getch() + 256;      // Bei Sondertasten: 
                                // Erweiteter Code + 256.
    va_start(argp, max);        // argp initialisieren.
    
    do     // Mit Zeichen der Abbruchliste vergleichen
      if( c == (breakc = va_arg(argp,int)) )
         return(breakc);
    while( breakc != '\r');

    va_end( argp);
    
    if( c == '\b' &&  nc > 0)    // Backspace? 
    {
        --nc,  --puffer;
        _putch(c);  _putch(' '); _putch(c);
    }
    else if( c >= 32  &&  c <= 255  &&  nc < max )
    {               // Zeichen -> Puffer und ausgeben.
       ++nc,  *puffer++ = c;  _putch(c);
    }
    else if( nc == max)    // Ende des Puffer erreicht? 
       _putch('\a');       // Ton ausgeben. 
    }
}

#include <iostream>
using namespace std;

int main()
{
    char s[11];
    int cBreak = 0;

    cout << "\nGeben Sie ein Wort ein "
         << "\n(Abbruch mit Tab, Blanc, Esc, Return):" 
         << endl;
    cBreak = input(s, 10, '\t', ' ', 27, '\r'); 

    cout << "\nZeichen-Code, mit dem die Eingabe beendet wurde: "
         << cBreak << endl;

    cout << "\n\nUnd hier Ihre Eingabe: \n";
    cout << s << endl;

    return 0;
}
