// ---------------------------------------------------------
// initList.cpp:  Initialisierungslisten und range-based-for
// ---------------------------------------------------------

#include <vector>
#include <list>
#include <string>
#include <iostream>
#include "konto.h"
using namespace std;

int main()
{
   int arr[] { 1, 2, 3, 4, 5 };      // Ein int-Array initialisieren.
   for( int& el : arr)               // el ist jeweils eine Refernez auf ein Element.
   {
       el += 10;                     // Jedes Element verndern
       cout << el << "  ";           // und anzeigen.
   }
   cout << endl;

   // Ein vector-Objekt mit Konto-Elementen initialisieren:
   vector<Konto> kontoVec { Konto("Heidi", 12345UL, 1950.99),
                            Konto("Hansi", 54321UL, 1150.99),
                            Konto("Irmi",  98765UL, 950.99)  };
   // Vektor anzeigen:
   for( const auto& k : kontoVec)      // k ist eine read-only-Referenz
       k.display();

  // Eine Liste initialisieren.
   list<string> strList = { "Vivi", "Jeany", "Anna" };

   cout << "Die Liste enthaelt "
        << strList.size() << " Elemente:" << endl;
   for( const auto& str : strList)
       cout << str << "   ";
   cout << endl;

   return 0;
}
