// ----------------------------------------------------
// arrayDemo.cpp: Demo für den Container array<T,N>
// ----------------------------------------------------
#include <array>
#include <string>
#include <iostream>
using namespace std;

template<class Arr>
void showArray(Arr& a)       // Call by Reference
{
    for( auto& el : a)       // Ausgabe mit range-for-Schleife.
        cout << el << "  ";
    cout << endl;
}

int main()
{
   array<int,5> arr1,                       // int-Arrays ohne und mit
                arr2 = { 1, 2, 3, 4, 5 };   // Initialisierung.
   array arr3{ 1, 5, 4, 3, 2 };             // Auch möglich (C++17).

   arr1 = arr2;                             // Zuweisung gleich
                                            // grosser Arrays.
   cout << "1. Array nach der Zuweisung:\n";
   showArray(arr1);

   arr3[0] = 10;                            // Index-Operator.
   array<int,5> arr4(arr3);                 // Kopie von arr3.
   cout << "Die Kopie des 3. Arrays:\n";
   showArray(arr4);

   arr1.fill(1);                         // Mit dem Wert 1 füllen.
   if( arr1 < arr2)                      // true, da arr1[0] == arr2[0]
   {                                     // und arr1[1] < arr2[1].
       cout << "Der Array       ";  showArray(arr1);
       cout << "ist kleiner als ";  showArray(arr2);
   }

   // Ein "zweidimensionaler" Vektor:
   array<string, 3> wNamen = { "Emely", "Edith", "Romy"  },
                    mNamen = { "Anton", "Daniel", "Max" };
   array<array<string, 3>, 2> namen = { wNamen, mNamen };

   showArray(namen[0]);
   showArray(namen[1]);

   // Die globale Funktion to_array() verwenden (C++20):
   string strVec[] = { "Ein", "Beispiel", "mit", "Strings!"};
   auto strArr = to_array(strVec);   // array-Objekt
   showArray(strArr);

   return 0;
}
