// List.cpp: Die Methoden der Klasse InhomList
// ---------------------------------------------------

#include "List.h"
#include <typeinfo>   // Fr typeid

InhomList::InhomList(const InhomList& src)
{
   // An leere Liste die Elemente aus src anhngen.
   first = NULL;
   Cell *pEl = src.first;
   for(  ; pEl != NULL;  pEl = pEl->getNext() )
       if(typeid(*pEl) == typeid(DerivedEl))
           insert(dynamic_cast<DerivedEl*>(pEl)->getName(), 
                  dynamic_cast<DerivedEl*>(pEl)->getBem());
       else
           insert(dynamic_cast<BaseEl*>(pEl)->getName());
}
 
// Zuweisung:
InhomList& InhomList::operator=(const InhomList& src)
{
   // Speicher aller Elemente freigeben: 
   Cell *pEl = first,
        *next = NULL;
   while( pEl != NULL )
   {
      next = pEl->getNext();
      delete pEl;
      pEl = next;
   }

   first = NULL;                // Leere Liste

   // An leere Liste die Elemente aus src anhngen.
   pEl = src.first;
   
   for(  ; pEl != NULL;  pEl = pEl->getNext() )
      if(typeid(*pEl) == typeid(DerivedEl))
           insert(dynamic_cast<DerivedEl*>(pEl)->getName(), 
                  dynamic_cast<DerivedEl*>(pEl)->getBem());
      else
           insert(dynamic_cast<BaseEl*>(pEl)->getName());

   return *this;
}


InhomList::~InhomList()
{
   Cell *pEl = first,
        *next = NULL;
   while( pEl != NULL ) 
   {
      next = pEl->getNext();
      delete pEl;
      pEl = next;
   }
}

Cell* InhomList::getPrev(const string& n)
{
   Cell *pEl  = first,
        *prev = NULL;

   while( pEl != NULL  ) 
   {
      if( n > dynamic_cast<BaseEl*>(pEl)->getName() )
      {
          prev = pEl;
          pEl  = pEl->getNext();
      }
      else 
          return prev;
      
   }
   return prev;

}

void InhomList::insertAfter(const string& s, Cell* prev)
{
  if( prev == NULL )   // Vor allen anderen einfgen:
      first = new BaseEl( first, s); 
  else                 // In der Mitte oder am Ende: 
   {
     Cell* p = new BaseEl(prev->getNext(), s);
     prev->setNext(p);
   } 
}

    
 
void InhomList::insertAfter(const string& s, const string& b, Cell* prev)
{
  if( prev == NULL )   // Vor allen anderen einfgen:
     first = new DerivedEl( first, s, b); 
  else                 // In der Mitte oder am Ende: 
  { 
     Cell* p = new DerivedEl(prev->getNext(), s, b);
     prev->setNext(p);
  } 
}

void InhomList::insert(const string& n)
{
   Cell* pEl = getPrev(n);
   insertAfter(n, pEl);
}

void  InhomList::insert(const string& n, const string& b)
{
   Cell* pEl = getPrev(n);
   
   insertAfter(n, b, pEl);

}
    
void InhomList::displayAll() const
{
    Cell* pEl = first;

    while(pEl != NULL)
    {
        pEl->display();
        pEl = pEl->getNext();
    }
}