// cell.h: Definition der Klassen Cell, BaseEl und DerivedEl
// ------------------------------------------------------
#ifndef CELL_H
#define CELL_H

#include <string>
#include <iostream>
using namespace std;

class Cell
{
  private:
   Cell* next;

  protected:
   Cell(Cell* suc = NULL ){ next = suc; }

  public: 
   virtual ~Cell(){ }
   Cell* getNext() const { return next; }
   void  setNext(Cell* suc) { next = suc; }

   virtual void display() const = 0;
};

class BaseEl : public Cell
{
  private:
   string name;

  public:
   BaseEl( Cell* suc = NULL, const string& s = "")
       :  Cell(suc), name(s){}

   // Zugriffsmethoden:
   void    setName(const string& s){ name = s; }
   const string& getName() const { return name; }

   void display() const override
   { 
       cout << "\n----------------------------"
            << "\nName:      " << name << endl; 
   }
};

class DerivedEl : public BaseEl
{
   private:
     string bem;

   public:
     DerivedEl(Cell* suc = NULL,  const string& s="", const string& b="") 
         : BaseEl(suc, s), bem(b){ }
     // Zugriffsmethoden:
     void    setBem(const string& b){ bem = b; }
     const string& getBem() const { return bem; }

     void display() const override
     {
         BaseEl::display(); 
         cout << "Bemerkung: " << bem << endl;
     }
};
#endif
