// mitarb.h:  Definition der abstrakten Klasse Mitarbeiter
//            und davon abgeleiteter Klassen.
// -------------------------------------------------------
#ifndef MITARB_H
#define MITARB_H

#include <string>
#include <iostream>
#include <iomanip>
using namespace std;

class Mitarbeiter
{
   private:
     string name;
     // weitere Infos 
   public:
     Mitarbeiter( const string& s = "") : name(s) {}
     virtual ~Mitarbeiter() {};         // Destruktor

     const string&  getName() const{ return name; }
     void  setName( const string& n){ name = n; }

     virtual void display() const;

     virtual double einkommen() const = 0;

     virtual Mitarbeiter& operator=(const Mitarbeiter&);
};

class Arbeiter : public Mitarbeiter
{
   private:
     double lohn;
     int    std;

   public:
    Arbeiter(const string& s="", double l = 0.0, int h = 0)
             : Mitarbeiter(s), lohn(l), std(h) { }

    double getLohn() const { return lohn; }
    void   setLohn( double l ){ lohn = l; }

    int    getStd() const { return std; }
    void   setStd(int h ) { std = h; }

    void   display() const  override;
    double einkommen() const  override { return lohn * std; }
 
    Arbeiter& operator=(const Mitarbeiter&)  override; 
//    Mitarbeiter& operator=(const Mitarbeiter&)  override;
    Arbeiter& operator=(const Arbeiter&);  
};

class Angestellter : public Mitarbeiter
{
  private:
    double gehalt;       // Monatsgehalt
 
  public:
    Angestellter( const string& s="", double g = 0.0)
                : Mitarbeiter(s), gehalt(g){ }
 
    double getGehalt() const { return gehalt; }
    void   setGehalt( double g){ gehalt = g; }
 
    void   display() const override;
    double einkommen() const override { return gehalt; }

    Angestellter& operator=( const Mitarbeiter& )  override;
//    Mitarbeiter&  operator=( const Mitarbeiter&) override;
    Angestellter& operator=( const Angestellter& );   
};

#endif
