// -------------------------------------------------------
// fract_t.cpp
// Die Klasse Fraction testen.
// Module: fract_t.cpp  fraction.cpp
// -------------------------------------------------------
#include "fraction.h"
#include <iostream>
#include <cstdlib>         // Für exit()
using namespace std;

int main()
{
   try                 // Exception des Konstruktors testen:
   {
      Fraction c(5,0);
   }
   catch(Fraction::DivisionByZero& ) 
   {
     cout << "\nFraction: Fehler bei der Initialisierung."
          << "\nDer Nenner ist 0!\n";
   }

   Fraction a(1,3), b(3);
   
   try
   {
     cout << "\nEinige Testausgaben:\n\n";

     cout << " a = " << a << endl;
     cout << " b = " << b << endl;

     cout << " a + b = " << (a + b) << endl;
     cout << " a - b = " << (a - b) << endl;
     cout << " a * b = " << (a * b) << endl;
     b = 0;
     cout << " a / b = " << (a / b) << endl;   // Fehler!
   }
   catch(Fraction::DivisionByZero& ) 
   {
     cout << "\nFraction: Fehler bei der Division."
          << "\nDurch 0 kann nicht dividiert werden.\n";
   }
   
   cout << "  --a =  " <<  --a << endl;
   cout << "  ++a  = " <<  ++a << endl;

   a += Fraction(1,2);
   cout << " a+= 1/2;  a = " << a << endl;

   a -= Fraction(1,2);
   cout << " a-= 1/2;  a = " << a << endl;

   cout << "-b = " << -b << endl;

   cout << "\nUnd jetzt eine Eingabe\n";
   try
   {
     cin  >> a;
   }
   catch(Fraction::DivisionByZero&) 
   {
     cerr << "\nFehler beim Einlesen: Der Nenner ist 0.\n";
     exit(1);
   }

   cout << "\nIhre Eingabe: " << a << endl;

   return 0;
}
