// konto.h 
// Die Klasse Konto mit set- und get-Methoden.
// ----------------------------------------------------
#ifndef KONTO_H
#define KONTO_H

#include <iostream>
#include <iomanip>
#include <string>
using namespace std;

class Konto
{
  private:            // Geschtzte Elemente:
     string name;             // Kontoinhaber
     unsigned long nr;        // Kontonummer
     double stand;            // Kontostand
  public:             // ffentliche Schnittstelle:
                      // Konstruktoren, Destruktor:
     Konto( const string& k_name = "X",
            unsigned long k_nr   = 1111111L,
            double  k_stand      = 0.0)
     :name(k_name), nr(k_nr), stand(k_stand)    
     { }

     // Die get Methoden:
     const string& getName()  const { return name; }
     unsigned long getNr()    const { return nr; }
     double        getStand() const { return stand; }

     // Die set Methoden:
     bool setName( const string& s)
     {
        if( s.size() < 1)     // Kein leerer Name
          return false;
        name = s;
        return true; 
     }
     void setNr( unsigned long n) { nr = n; }
     void setStand(double x) { stand = x; }

     // Weitere Methoden:
     void display() const;
};

 // display() zeigt die Konto-Daten am Bildschirm an.
inline void Konto::display() const 
{
   cout << fixed << setprecision(2)
        << "--------------------------------------\n"
        << "Kontoinhaber:  " << name  << '\n'
        << "Kontonummer:   " << nr    << '\n'
        << "Kontostand:    " << stand << '\n'
        << "--------------------------------------" << endl;
}

#endif   //  KONTO_H
