// -----------------------------------------------------
// sieb.cpp 
// Mit dem Sieb des Eratosthenes Primzahlen finden.
// -----------------------------------------------------

#include <iostream>
#include <iomanip>
using namespace std;

#define LIMIT  1000                  // Obergrenze
bool flags[LIMIT] = { false, false}; // Vektor mit Flags

int main()
{
   int i, j;          // Indizes
   
   for( i = 2; i < LIMIT; ++i)
       flags[i] = true;        // Flags auf true setzen

   // Sieben:
   for( i = 2; i < LIMIT/2; ++i)
   {
      if( flags[i])            // Ist i eine Primzahl?
      {                        // Ja -> Vielfache lschen. 
         for( j = i+i; j < LIMIT; j += i)
            flags[j] = false;
      }
   }

   // Zhlen
   int count = 0;              // Zhler 
   for( i = 2; i < LIMIT; ++i)
      if(flags[i])             // Falls i Primzahl
        ++count;               // -> zhlen

   // Ausgabe:
   cout << "Es gibt " << count << " Primzahlen kleiner als " 
        << LIMIT << endl;

   cout << "\nPrimzahlen ausgeben? (j/n) ";

   char reply;  cin.get(reply);
   if( reply == 'j' || reply == 'J')
   {
     for( i = 2; i < LIMIT; ++i)
        if(flags[i])           // Falls i Primzahl
        {                      // -> ausgeben.
           cout.width(8);  cout << i;
        }
   }
   cout << endl;
   return 0;
}
