// FloatVek.cpp: 
// Implementierung der Methoden von FloatVek.
// -----------------------------------------------------

#include "FloatVek.h"
#include <iostream>
using namespace std;

FloatVek::FloatVek( int n )
{
    max = n;   anz = 0;        // max und anz setzen.
    vekPtr = new float[max];   // Speicher reservieren
}

FloatVek::FloatVek(int n, float wert)
{
   max = anz = n;
   vekPtr  = new float[max];
   
   for( int i=0; i < anz; ++i)
        vekPtr[i] = wert;
}

FloatVek::FloatVek(const FloatVek& src)
{
    max = src.max;
    anz = src.anz;
    vekPtr = new float[max];

    for( int i = 0; i < anz; i++ )
        vekPtr[i] = src.vekPtr[i];
}

FloatVek::~FloatVek()
{
   delete[] vekPtr;
}

FloatVek& FloatVek::operator=( const FloatVek& src )
{
   if( this != &src )         // Keine Selbstzuweisung!
   { 
       max = src.max; 
       anz = src.anz;
    
       delete[] vekPtr;            // Speicher freigeben,
       vekPtr = new float[max];    // neu reservieren.

       for( int i=0; i < anz; ++i) // Elemente kopieren.
          vekPtr[i] = src.vekPtr[i];
   }
   return *this;
}

float& FloatVek::operator[]( int i )
{
   if( i < 0 || i >= anz )
   { 
      cerr << "\n class FloatVek: Out of Range! "; 
      exit(1);
   }
   return vekPtr[i];
}

float FloatVek::operator[]( int i ) const
{
   if( i < 0 || i >= anz )
   { 
      cerr << "\n class FloatVek: Out of Range! "; 
      exit(1);
   }
   return vekPtr[i];
}

bool FloatVek::append( float wert) 
{ 
   if(anz < max)
   {  
      vekPtr[anz++] = wert;
      return true;
   }
   else 
      return false;
}

bool FloatVek::remove(int pos)
{ 
   if( pos >= 0 && pos < anz)
   {
      for( int i = pos; i < anz-1; ++i) 
         vekPtr[i] = vekPtr[i+1];
      --anz;
      return true;
   }
   else
      return false;
}
