// ------------------------------------------------------
// vektor_t.cpp
// Zum Testen des Klassen-Templates Vektor<T,n>.
// ------------------------------------------------------
#include "vektor.h"
#include "DayTime.h"
#include <cstdlib>
#include <iostream>
#include <iomanip>
using namespace std;

typedef Vektor<int, 100>   IntVek;
typedef Vektor<double>     DoubleVek;
typedef Vektor<DayTime, 5> DayTimeVek;

int main()
{
  try
  {
    const DoubleVek kvd(10, 9.9); 
    DoubleVek vd;

    cout << "\nHier der konstante double-Vektor: \n";
    cout << setw(8) << kvd;

    vd = kvd;
    cout <<  "\nHier der neue double-Vektor:    " << endl;
    cout << setw(8) << vd;

    vd.remove(3);          // Element beim Index 3
                           // lschen.
    vd.append(10.0);       // Neues Element hinzufgen.
    vd.append(20.0);       // Und nochmal!

    cout <<  "\nHier der geaenderte double-Vektor: " << endl;
    cout << setw(8) << vd;

    IntVek vi;

    int i;
    for(i=0; i < 10; i++)
        vi.append(rand()%100);

    cout << "\nHier der int-Vektor: \n";
    cout << setw(5) << vi;

    vi += vi;
    cout << "\nVektor verdoppelt: \n";
    cout << setw(5) << vi;

    IntVek kvi(vi);
    cout << "\nHier die Kopie des int-Vektors: \n";
    cout << setw(5) << kvi;

    DayTimeVek vt;
    DayTime temp;

    cout << "\nBis zu drei Tageszeiten eingeben: \n";
    for(i=0; i < 3; ++i)
    { 
       if( !(cin >> temp))
          break;
       vt.append(temp);
    }

    cout << "\nHier der Vektor mit Objekten vom Typ DayTime: \n";
    cout << setw(20) << vt;
  }
  catch(BadIndex& err)
  {
      cerr << "\nIndex " << err.getBadIndex() << " unzulssig\n";
      exit(1);
  }
  catch(OutOfRange& )
  {
      cerr << "\nVektor voll!\n";
      exit(2);
  }

  return 0;
}
