// -------------------------------------------
// list_t.cpp:  Zum Testen von Listenoperationen
// -------------------------------------------

#include <list>
#include <cstdlib>
#include <iostream>
#include <ctime>
using namespace std;

typedef list<int> INTLIST;
int display( const INTLIST& c);

int main()
{
  INTLIST ls, sls;        // Zwei leere Listen.

  srand( (unsigned int)time(NULL));  // Initialisierung des
                                     // des Zufallszahlen-Generators
  for( int i=1; i<=3; i++)
    ls.push_back( rand()%10 );       // z.B. 1 7 4

  cout << "Erste Liste ls: " << endl;
  display(ls);

  cout << "Erstes Element anhaengen:" << endl;
  ls.push_back(ls.front());          // 1 7 4 1
  display(ls);  

  cout << "Invertieren:" << endl;
  ls.reverse();                     // 1 4 7 1
  display(ls);

  cout << "Sortieren:" << endl;
  ls.sort();                        // 1 1 4 7
  display(ls);

  cout << "Zweite Liste sls:" << endl;
  for( int i=1; i<=3; i++)
    sls.push_back( rand()%10 );     // z.B. 0 9 4
  display(sls);

  cout << "Erstes Objekt von sls vor letztes von ls:" << endl;
  auto pos = ls.end();
  ls.splice(--pos, sls, sls.begin());   // 1 1 4 0 7
  display(ls); 

  cout << "Zweite Liste sls:" << endl; 
  display(sls);                      // 9 4

  cout << "Sortieren und Mischen:" << endl;
  ls.sort();                         // 0 1 1 4 7 
  sls.sort();                        // 4 9
  ls.merge(sls);                     // 0 1 1 4 4 7 9
  display(ls); 

  cout << "Eindeutig machen:" << endl; 
  ls.unique();                       // 0 1 4 7 9
  display(ls);

  return 0;
}


int display(const INTLIST& c)
{
   int z = 0;                           // Zhler

   for( auto pos = c.begin(); pos != c.end(); pos++, z++)
     cout << *pos << ' ';
   cout << endl;
   cin.get();

   return z;
}
