// -----------------------------------------------------
// index_t.cpp : Zum Testen der Klasse IndexFileSystem
// -----------------------------------------------------
#include <iostream>
#include <string>
#include "index.h"
#include "konto.h"
using namespace std;

int main()
{
  try
  {
    IndexFileSystem  data("KontoTest");

    Konto kto1( "Vivi", 490UL, 12340.57);
    data.insert( kto1 ); 

    SparKonto kto2( "Daniel Reich", 590UL, 40321.19, 2.5);
    data.insert( kto2 );

    GiroKonto kto3( "Jeany", 390UL, 12340.20, 10000.0, 12.9);
    data.insert( kto3 );

    data.displayIndexFile();   cin.get();
    data.displayKontoFile();

    unsigned long key;
    cout << "Key? ";   cin >> key;

    Konto* p = data.retrieve(key);
    if( p  != NULL )
    {
        p->display();
        delete p;
    }
    else
      cout << "Schluessel " << key << " nicht gefunden!" << endl; 
  }

  catch(open_error& err)
  {
      cerr << "Fehler beim Oeffnen der Datei: " << err.getName() << endl;
      exit(1);
  }
  catch(write_error& err)
  {
      cerr << "Fehler beim Schreibzugriff in Datei: " << err.getName() << endl;
      exit(1);
  }
  catch(read_error& err)
  {
      cerr << "Fehler beim Lesezugriff auf Datei: " << err.getName() << endl;
      exit(1);
  }

  return 0;
}
