// variant_demo.cpp: Das Template variant verwenden.
// -------------------------------------------------
#include <variant>
#include <iostream> 
using namespace std;

int main()
{
    try
    {
        variant<long, double>  var0(12.3), var1;
        cout << "var0.index = " << var0.index() << '\n'   // 1
             << "var1.index = " << var1.index() << endl;  // 0

        var1 = 111L;
        cout << get<0>(var1) << endl;     // OK.
        ++get<0>(var1);
        cout << get<long>(var1) << endl;  // Auch OK.

        var1 = var0;
        // Speichert var1 ein double?
        if( holds_alternative<double>(var1) )
            cout << get<double>(var1) << endl;

        // double x = get<2>(var1);     // Compiler meldet Fehler:
                                        // Nur Index 0 oder 1 mglich.
        cout << get<0>(var1) << endl;   // Exception! 
                                        // var1 speichert ein double.
        return 0;
    }
    catch( const bad_variant_access& ex)
    {
        cerr << ex.what() << endl;
    }
}
