// -------------------------------------------------------
// WebAccount.h
// Definition der Klassen WebAccount und UserTable
// zur passwortgeschtzten Benutzerverwaltung. 
// -------------------------------------------------------
#ifndef WEBACCOUNT_H
#define WEBACCOUNT_H

#include <unordered_map>
#include <string>
#include <iostream>
using namespace std;

class WebAccount
{
    string user;
    bool login;
  public:
    WebAccount(const string& s) : user(s), login(false){}

    void   setUser(const string s){ user = s; }
    string getUser() const { return user; }
    void   setLogin(bool flag){ login = flag; }
    bool   getLogin() const { return login; }
};

typedef unordered_multimap<size_t, WebAccount>
                                     UNORDERED_MULTIMAP;
typedef UNORDERED_MULTIMAP::iterator ITERATOR;

class UserTable
{
  private:
    UNORDERED_MULTIMAP ht;
    hash<string> hasher;

    ITERATOR find(const string& pw, const string& s);
    bool isUser(const string& pw, const string& s);

  public:
    bool addUser(const string& pw, const string& s);

    bool removeUser(const string& pw, const string& s);

    bool login(const string& pw, const string& s);
    bool logout(const string& pw, const string& s);

    void displayActiveUsers();
};

#endif   //  WEBACCOUNT_H
