// lock.cpp
// Verwendung der Klasse lock_guard
// -------------------------------------------------------------
#include <thread>
#include <mutex>
#include <iostream>
using namespace std;

mutex mtx; 
unsigned long summe = 0; 

class Add 
{
    int fct;

    long nextSum()       // Fhrt eine "lange" Berechnung aus:
    {                    // summe += fct.
        for(int i=1; i <= fct; i++)
            summe++; 
        return summe; 
    }
  public:
    Add(int n = 256) : fct(n){}       // Konstruktor

    void operator()(int m)            // nextSum() m Mal ausfhren: 
    {                                 // summe += m * fct.
    // Ein Lock sichert, dass die Berechnung nicht unterbrochen wird.
       lock_guard<mutex> lock(mtx);   // Lock anlegen.

       for(int i=1; i <= m; i++)
       {
         summe = nextSum(); 
         // Ergebnis prfen: Muss durch fct teilbar sein.
         if( summe % fct != 0 )       // nicht korrekt:
            cout << "\nThread-ID " << this_thread::get_id() 
                 << ": Ergebnis nicht durch " 
                 << fct << " teilbar!";
       }
       cout << "Zwischenergebnis: " << summe << endl; 
    }
};

int main()
{
       Add d;               // Vielfache von 256 berechnen
       thread t1(d,10);     // und separat aufaddieren:
       thread t2(d,20);     // 10 * 256 + 20*256

       t1.join(); t2.join(); 

       cout << "Endergebnis: " << summe << endl;
       return 0;
}
